
JSB.newAddon = function (mainPath) {
// try {
  

  JSB.require('utils')
  if (!chatAIUtils.checkMNUtilsFolder(mainPath)) { return undefined }
  JSB.require('webviewController');
  JSB.require('notificationController')
  JSB.require('dynamicController')
  JSB.require('sideOutputController')
  // chatAIConfig.remove("MNChatglm_builtInKeys")
// } catch (error) {
//   Application.sharedInstance().showHUD(error, Application.sharedInstance().focusWindow, 2)
//   return undefined
// }
  /** @return {MNChatglmClass} */
  const getMNChatglmClass = ()=>self  
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_config")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_promptNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_currentPrompt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_fileId');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_usage');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_dynamicPrompt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_knowledge');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_builtInKeys');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_prompts');

  var MNChatglmClass = JSB.defineClass(
    'MNChatglm : JSExtension',
    { /* Instance members */
      sceneWillConnect: async function () { //Window initialize
        if (!(await chatAIUtils.checkMNUtil(true))) return
      try {
        let self = getMNChatglmClass()
        self.init(mainPath)
        self.isNewWindow = false;
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
        self.addObserver('onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        self.addObserver('onPopupMenuOnNote:', 'PopupMenuOnNote')
        self.addObserver('onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote')
        self.addObserver('onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection')
        self.addObserver('onProcessNewExcerpt:', 'ProcessNewExcerpt')
        self.addObserver('onChatOnNote:', 'chatOnNote')
        self.addObserver('onChatOnQuestion:', 'chatOnQuestion')
        self.addObserver('onCustomChat:', 'customChat')
        self.addObserver('onOpenFloat:', 'chatAIOpenFloat')
        self.addObserver('onInsertChatModeReference:', 'insertChatModeReference')
        MNUtil.addObserver(self, 'onCloudConfigChange:', 'NSUbiquitousKeyValueStoreDidChangeExternallyNotificationUI')
        // self.addObserver('onKeyboardWillShowNotification:', "UIResponderKeyboardWillShowNotification")
        } catch (error) {
          chatAIUtils.addErrorLog(error, "sceneWillConnect")
      }
      },

      sceneDidDisconnect: function () { // Window disconnect 在插件页面关闭插件和删除插件
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        let names = [
          'PopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote', 'ClosePopupMenuOnSelection','ProcessNewExcerpt','chatOnNote','chatOnQuestion','customChat','chatAIOpenFloat','NSUbiquitousKeyValueStoreDidChangeExternallyNotificationUI'
        ]
        self.removeObservers(names)
      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: async function (notebookid) {
        if (!(await chatAIUtils.checkMNUtil(true,0.1))) return
      try {
        let self = getMNChatglmClass()
        self.init(mainPath)
        chatAIUtils.forceToRefresh = true
        chatAIUtils.ensureChatAIController()
        chatAIUtils.ensureNotifyController()
        MNUtil.refreshAddonCommands()
        MNUtil.delay(1).then(()=>{
          if (chatAIConfig.autoImport(true)) {
            chatAIConfig.import(false)
          }
          MNUtil.studyView.becomeFirstResponder()
        })
      } catch (error) {
        chatAIUtils.addErrorLog(error, "notebookWillOpen")
      }
      },
      notebookWillClose: function (notebookid) {
        if (typeof MNUtil === 'undefined') return
        if (chatAIUtils.notifyController.connection) {
          chatAIUtils.notifyController.connection.cancel()
          delete chatAIUtils.notifyController.connection
        }



        // removeObservers(self,['PopupMenuOnSelection','ClosePopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote'])
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        // MNUtil.showHUD("controllerWillLayoutSubviews")
        if (typeof MNUtil === 'undefined') return
        if (controller !== MNUtil.studyController) {
          return;
        };
        let studyFrame = MNUtil.studyView.bounds
        let windowFrame = MNUtil.currentWindow.bounds
        // if (MNNote.getFocusNotes().length > 1) {
        //   MNUtil.showHUD("Multiple notes selected")
        // }
        if (!chatAIUtils.chatController.view.hidden) {
          let currentFrame = chatAIUtils.chatController.currentFrame
          if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
            currentFrame.x = studyFrame.width-currentFrame.width*0.5              
          }

          if (currentFrame.y >= studyFrame.height) {
            currentFrame.y = studyFrame.height-20              
          }
          chatAIUtils.chatController.view.frame = currentFrame
          chatAIUtils.chatController.currentFrame = currentFrame
        }
        if (!chatAIUtils.notifyController.view.hidden && !chatAIUtils.notifyController.onAnimate) {
          let currentFrame = chatAIUtils.notifyController.currentFrame
          currentFrame.height = Math.min(currentFrame.height,windowFrame.height - currentFrame.y)
          currentFrame.y = chatAIUtils.getY()
          chatAIUtils.notifyController.currentFrame = currentFrame
          chatAIUtils.notifyController.view.frame = currentFrame
          if (chatAIUtils.notifyController.onChat) {
            chatAIUtils.notifyController.setChatLayout()
          }
          
        }
        if (chatAIUtils.isMN4() && MNExtensionPanel.on && chatAIUtils.sideOutputController) {
          chatAIUtils.sideOutputController.view.frame = {x:0,y:0,width:MNExtensionPanel.width,height:MNExtensionPanel.height}
          chatAIUtils.sideOutputController.chatView.frame = {x:0,y:0,width:MNExtensionPanel.width,height:MNExtensionPanel.height}
        }
        if (chatAIUtils.dynamicController && !chatAIUtils.dynamicController.view.hidden && !chatAIUtils.dynamicController.onAnimate) {
          // let lastFrame = chatAIUtils.dynamicController.lastFrame
          // lastFrame.x = MNUtil.constrain(lastFrame.x, 0, studyFrame.width-300)
          // lastFrame.y = MNUtil.constrain(lastFrame.y, 0, studyFrame.height-200)
          chatAIUtils.dynamicController.view.setNeedsLayout()

        }
      },

      queryAddonCommandStatus: function () {
        if (!chatAIUtils.checkLogo()) {return null}
        chatAIUtils.ensureChatAIController()
        chatAIUtils.ensureNotifyController()
        chatAIUtils.notifyController.checkTheme(true)
        return {
          image: 'logo.png',
          object: self,
          selector: 'toggleAddon:',
          checked: chatAIConfig.config.autoAction
        };
      },
      onPopupMenuOnSelection: async function (sender) { // Selecting text on pdf or epub
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        try {
          

        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        chatAIUtils.currentSelection = sender.userInfo.documentController.selectionText;
        if (chatAIUtils.isMN4() && chatAIUtils.sideOutputController && chatAIUtils.sideOutputController.userInput) {
          chatAIUtils.sideOutputController.userInput.endEditing(true)
        }
        // if (chatAIUtils.dynamicController) {
        //   // chatAIUtils.dynamicController.promptInput.endEditing(true)
        //   chatAIUtils.dynamicController.promptInput.resignFirstResponder()
        // }
        self.dateGetText = Date.now();
        self.textProcessed = false
        self.onPopupMenuOnSelectionTime = Date.now()
        let studyFrame = MNUtil.studyView.frame
        let winFrame = MNUtil.parseWinRect(sender.userInfo.winRect)
        let xOffset = sender.userInfo.arrow===1 ? 20: -80
        let yOffset = sender.userInfo.arrow===1 ? -60: -30
        winFrame.x = winFrame.x+xOffset-studyFrame.x
        winFrame.y = winFrame.y+yOffset
        if (winFrame.x < 0) {
          winFrame.x = 0
        }
        if (winFrame.x > studyFrame.width-40) {
          winFrame.x = studyFrame.width-40
        }
        let dynamicFrame = MNUtil.genFrame(winFrame.x, winFrame.y, 40, 40)
        await self.checkDynamicController(dynamicFrame)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.dynamicController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.dynamicController.view)
        // }
        chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
        if (chatAIConfig.config.dynamic) {
          chatAIUtils.dynamicController.view.hidden = false
        }
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.currentNoteId = undefined
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,-1,"onSelection")) {
          // MNUtil.showHUD("should prevent")
          return
        }
        chatAIUtils.notifyController.noteid = undefined
        chatAIUtils.chatController.askWithDelay()
        if (self.viewTimer) self.viewTimer.invalidate();
      } catch (error) {
          chatAIUtils.addErrorLog(error, "onPopupMenuOnSelection")
      }
      },
      onClosePopupMenuOnSelection: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        // MNUtil.showHUD("message")
        if (!MNUtil.checkSender(sender,self.window)) return;// Don't process message from other window
        chatAIUtils.onClosePopupMenuOnSelectionTime = Date.now()
        await MNUtil.delay(0.1)
        if (!chatAIUtils.dynamicController.view.hidden && (chatAIUtils.onClosePopupMenuOnSelectionTime>chatAIUtils.onPopupMenuOnSelectionTime+300) && (chatAIUtils.onClosePopupMenuOnSelectionTime>chatAIUtils.onPopupMenuOnNoteTime+300) && !chatAIUtils.dynamicController.onClick) {
          MNUtil.animate(()=>{
            chatAIUils.dynamicController.view.layer.opacity = 0
          },0.1).then(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = 1
            chatAIUtils.dynamicController.view.hidden = true
          })
          // await MNUtil.delay(0.2)
          // if ((chatAIUtils.onClosePopupMenuOnSelectionTime>chatAIUtils.onPopupMenuOnSelectionTime+300) && (chatAIUtils.onClosePopupMenuOnSelectionTime>chatAIUtils.onPopupMenuOnNoteTime+300) && !chatAIUtils.dynamicController.onClick) {
          // }
          // let preOpacity = chatAIUtils.dynamicController.view.layer.opacity
          // MNUtil.animate(()=>{
          //   chatAIUtils.dynamicController.view.layer.opacity = 0
          // },0.1).then(()=>{
          //   chatAIUtils.dynamicController.view.layer.opacity = preOpacity
          //   chatAIUtils.dynamicController.view.hidden = true
          // })
          return
        }
      },
      /**
       * 
       * @param {{userInfo:{noteid:String}}} sender 
       * @returns 
       */
      onProcessNewExcerpt: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!MNUtil.checkSender(sender)) return; // Don't process message from other window
      try {
        let note = MNNote.new(sender.userInfo.noteid)
        let currentNoteId = sender.userInfo.noteid
        self.notShow = false
        // if (note.excerptPic) {
        //   return
        // }


        // let comments = note.comments
        // copyJSON(comments)
        let text = await chatAIUtils.getTextForSearch(note)
        chatAIUtils.currentNoteId = currentNoteId
        chatAIUtils.currentSelection = text
        self.dateGetText = Date.now();
        self.textProcessed = false


        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,note.colorIndex,"onNewExcerpt")) {
          return
        }
        if (chatAIConfig.getConfig("newExcerptTagDetection")) {
          // let tags = note.tags
          // MNUtil.copyJSON(tags)
          // let tags = chatAIUtils.extractTagsFromNote(note).map(tag=>tag.slice(1))
          let promptKeys = chatAIConfig.config.promptNames
          let promptNames = promptKeys.map(key=>chatAIConfig.prompts[key].title)
          let commonPrompts = chatAIUtils.findCommonElements(note.tags, promptNames)
          if (commonPrompts.length) {
            let firstPrompt = commonPrompts[0]
            note.removeCommentByIndex(0)
            let promptKey = chatAIUtils.findKeyByTitle(chatAIConfig.prompts, firstPrompt)
            chatAIUtils.notifyController.noteid = currentNoteId
            chatAIUtils.chatController.askWithDelay(promptKey)
          }
          return
        }
        chatAIUtils.notifyController.noteid = currentNoteId
        chatAIUtils.chatController.askWithDelay()
      } catch (error) {
        MNUtil.showHUD("Error in onProcessNewExcerpt:"+error)
      }
      },
      onPopupMenuOnNote: async function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        let note = MNNote.new(sender.userInfo.note.noteId)
        let currentNoteId = note.noteId
        chatAIUtils.onPopupMenuOnNoteTime = Date.now()
        if (chatAIUtils.isMN4() && chatAIUtils.sideOutputController && chatAIUtils.sideOutputController.userInput) {
          chatAIUtils.sideOutputController.userInput.endEditing(true)
        }
        // if (chatAIUtils.dynamicController) {
        //   chatAIUtils.dynamicController.view.becomeFirstResponder()
        //   // chatAIUtils.dynamicController.promptInput.endEditing(true)
        //   // chatAIUtils.dynamicController.promptInput.resignFirstResponder()
        //   // MNUtil.studyView.becomeFirstResponder()
        // }
      try {
        let studyFrame = MNUtil.studyView.frame
        let winFrame = MNUtil.parseWinRect(sender.userInfo.winRect)
        let yOffset = -25
        let xOffset = winFrame.width+1
        if (winFrame.width===10) {
          //1是菜单在下方出现,2是菜单在上方出现
          xOffset = sender.userInfo.arrow===1 ? 20: -80
          yOffset = sender.userInfo.arrow===1 ? -60: -30
          // if (sender.userInfo.arrow===1) {
          //   yOffset = 60
          //   xOffset = 30
          // }else{
          //   yOffset = 15
          //   xOffset = -65
          // }
                // let xOffset = sender.userInfo.arrow===1 ? 20: -50
        // let yOffset = sender.userInfo.arrow===1 ? -50: -40
        }
        // let xOffset = winFrame.width===10?winFrame.width+20:winFrame.width
        let dynamicFrame = MNUtil.genFrame(winFrame.x+xOffset-studyFrame.x, winFrame.y+yOffset, 40, 40)
        if (dynamicFrame.y < 10) {
          dynamicFrame.y = 10
        }
        if (dynamicFrame.x > studyFrame.width-72) {
          dynamicFrame.x = studyFrame.width-72
        }
        // return
        await self.checkDynamicController(dynamicFrame)
        chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.dynamicController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.dynamicController.view)
        // }
        if (chatAIConfig.config.dynamic) {
          chatAIUtils.dynamicController.view.hidden = false
        }

        chatAIUtils.notifyController.notShow = false
        chatAIUtils.currentNoteId = currentNoteId
        // showHUD(currentNoteId)

        let text = await chatAIUtils.getTextForSearch(note)
        chatAIUtils.currentSelection = text
        if (!text) {
          return
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        if (self.viewTimer) self.viewTimer.invalidate();
        // MNUtil.showHUD("message")
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,note.colorIndex+16,"onNote")) {
          return
        }
        self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = sender.userInfo.note.noteId
        let question = await chatAIUtils.chatController.getQuestion()
        let sameQuestion = false
        if (self.lastQuestion) {
          sameQuestion = (JSON.stringify(question) === JSON.stringify(self.lastQuestion))
        }
        if (!chatAIUtils.notifyController.view.hidden && sameQuestion) {
          return
        }
        self.lastQuestion = await chatAIUtils.chatController.askWithDelay()
      } catch (error) {
        MNUtil.showHUD("Error in onPopupMenuOnNote: "+error)
      }
      },
      onClosePopupMenuOnNote: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        if (chatAIUtils.currentNoteId === sender.userInfo.noteid && Date.now()-self.dateGetText < 500) {
          chatAIUtils.notifyController.notShow = true
        }

        chatAIUtils.onClosePopupMenuOnNoteTime = Date.now()
        if (chatAIUtils.currentNoteId === sender.userInfo.noteid && Date.now()-chatAIUtils.onPopupMenuOnNoteTime < 500) {
          self.notShow = true
        }
        await MNUtil.delay(0.1)
        if (chatAIUtils.onClosePopupMenuOnNoteTime>chatAIUtils.onPopupMenuOnNoteTime+300 && !chatAIUtils.dynamicController.onClick) {
          MNUtil.animate(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = 0
          },0.1).then(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = 1
            chatAIUtils.dynamicController.view.hidden = true
          })
          return
        }
      },
      onChatOnNote: async function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkCouldAsk()) {
          return
        }
  // if (!self.response) {
  //   self.response = ""
  // }
  // self.response = self.response+"time:"+Date.now()
  // copy(self.response)
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (chatAIUtils.notifyController.onChat) {
          return
        }
      try {
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.notifyController.called = true
        let currentNoteId = sender.userInfo.noteid
        let note = MNNote.new(currentNoteId)
        chatAIUtils.currentNoteId = currentNoteId
        let text = await chatAIUtils.getTextForSearch(note)
        if (!text) {
          return
        }
        chatAIUtils.currentSelection = text
        self.dateGetText = Date.now();
        self.textProcessed = false
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!chatAIUtils.chatController.view.window) return;
        // self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = note.noteId
        chatAIUtils.notifyController.notifyLoc = chatAIUtils.chatController.notifyLoc
        chatAIUtils.chatController.ask()
      } catch (error) {
        MNUtil.showHUD(error)
      }
      },
      onCustomChat: function (sender) {
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (!chatAIUtils.checkCouldAsk()) {
          return
        }
        // chatAIUtils.copyJSON(sender.userInfo)
        if (sender.userInfo.prompt) {
          let prompt = sender.userInfo.prompt
          let promptKeys = chatAIConfig.config.promptNames
          let promptNames = promptKeys.map(key=>chatAIConfig.prompts[key].title)
          let commonPrompts = chatAIUtils.findCommonElements([prompt], promptNames)
          if (commonPrompts.length) {
            let firstPrompt = commonPrompts[0]
            let promptKey = chatAIUtils.findKeyByTitle(chatAIConfig.prompts, firstPrompt)
            chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
            chatAIUtils.chatController.ask(promptKey)
          }
          return
        }else if(sender.userInfo.user){
          let question = [{role:"user",content:sender.userInfo.user}]
          if (sender.userInfo.system) {
            question.unshift({role:"system",content:sender.userInfo.system})
          }
          chatAIUtils.notifyController.customAsk(question)
        }else{
          chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
          chatAIUtils.notifyController.text = chatAIUtils.currentSelection
          chatAIUtils.chatController.ask()
        }
      },
      onInsertChatModeReference: function (sender) {
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (chatAIUtils.isMN3()) {
          MNUtil.showHUD("Only available in MN4")
          return
        }
        if (!chatAIUtils.sideOutputController) {
          try {
            chatAIUtils.sideOutputController = sideOutputController.new();
            MNUtil.toggleExtensionPanel()
            MNExtensionPanel.show()
            MNExtensionPanel.addSubview("chatAISideOutputView", chatAIUtils.sideOutputController.view)
            let panelView = MNExtensionPanel.view
            chatAIUtils.sideOutputController.view.hidden = false
            chatAIUtils.sideOutputController.view.frame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
            chatAIUtils.sideOutputController.currentFrame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
            // MNUtil.toggleExtensionPanel()
          } catch (error) {
            chatAIUtils.addErrorLog(error, "onInsertChatModeReference")
          }
        }else{
          MNExtensionPanel.show("chatAISideOutputView")
        }

        let contents = sender.userInfo.contents
        let method = sender.userInfo.method ?? "append"
        if (method === "append") {
          chatAIUtils.sideOutputController.addToInput(contents[0].content)
          return
        }
        if (method === "replace") {
          chatAIUtils.sideOutputController.replaceInput(contents[0].content)
          return
        }
      },
      onChatOnQuestion: function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
      try {
        let self = getMNChatglmClass()
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.notifyController.called = true
        let question = sender.userInfo.question
        chatAIUtils.currentNoteId = undefined
        chatAIUtils.currentSelection = ""
        self.dateGetText = Date.now();
        self.textProcessed = false
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!chatAIUtils.chatController.view.window) return;
        // self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = undefined
        if (sender.userInfo.model) {
          chatAIConfig.config.currentModel = sender.userInfo.model
        }else{
          chatAIConfig.config.currentModel = chatAIConfig.config.model
        }
        if (/{{knowledge}}/.test(question)) {
          let knowledge = chatAIConfig.knowledge
          if (knowledge && knowledge.trim() != "") {
            question = question.replace('{{knowledge}}',`
以及部分参考翻译
'''
${knowledge}
'''`)
          }else{
            question = question.replace('{{knowledge}}',``)
          }
        }
        chatAIUtils.notifyController.ask(question,chatAIConfig.currentPrompt)
      } catch (error) {
        chatAIUtils.addErrorLog(error, "onChatOnQuestion")
      }
      },
      onCloudConfigChange: async function (sender) {
        let self = getMNChatglmClass()
        if (typeof MNUtil === 'undefined') return
        if (self.window !== MNUtil.currentWindow) {
          return
        }
        if (!chatAIUtils.checkSubscribe(false,false,true)) {
          return
        }
        let iCloudSync = chatAIConfig.getConfig("syncSource") === "iCloud"
        if(!iCloudSync || !chatAIConfig.autoImport(true)){
          return
        }

        // self.ensureView()
        self.checkUpdate()
      },
      onOpenFloat: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        try {
          // MNUtil.copyJSON(sender.userInfo.beginFrame)
          let beginFrame = sender.userInfo.beginFrame
          if (!chatAIUtils.dynamicController) {
            chatAIUtils.initDynamicController()
            chatAIUtils.dynamicController.mainPath = mainPath;
            chatAIUtils.dynamicController.firstFrame = beginFrame
            chatAIUtils.dynamicController.view.hidden  = true
            chatAIUtils.dynamicController.view.layer.opacity = 0
          }
          chatAIUtils.dynamicController.lastFrame = beginFrame
          chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
          chatAIUtils.refreshCurrent()
          chatAIUtils.dynamicController.openInput()
        } catch (error) {
          chatAIUtils.addErrorLog(error, "onOpenFloat")
        }
        // MNUtil.showHUD("Float Window")

      },
      
      onKeyboardWillShowNotification: async function (notification) {
        MNUtil.showHUD("KeyboardWillShowNotification")
      },
      syncConfig :async function (params) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        chatAIConfig.sync()
      },
      openFloat: async function (beginFrame) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        try {
        if (!chatAIUtils.dynamicController) {
          chatAIUtils.initDynamicController()
          chatAIUtils.dynamicController.mainPath = mainPath;
          chatAIUtils.dynamicController.firstFrame = beginFrame
          chatAIUtils.dynamicController.view.hidden  = true
          chatAIUtils.dynamicController.view.layer.opacity = 0
        }
        chatAIUtils.dynamicController.lastFrame = beginFrame
        chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
        chatAIUtils.refreshCurrent()
        chatAIUtils.dynamicController.openInput()
        } catch (error) {
          chatAIUtils.addErrorLog(error, "openFloat")
        }
      },
      openSetting:function (params) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        if (chatAIUtils.chatController.view.hidden) {
          if (chatAIUtils.chatController.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)
            let buttonFrame = chatAIUtils.addonBar.frame
            let width = 330
            if (buttonFrame.x <120) {
              chatAIUtils.chatController.view.frame = {x:buttonFrame.x+45,y:buttonFrame.y,width:width,height:465}
            }else{
              chatAIUtils.chatController.view.frame = {x:buttonFrame.x-width-5,y:buttonFrame.y,width:width,height:465}
            }
            chatAIUtils.chatController.currentFrame = chatAIUtils.chatController.view.frame
            chatAIUtils.chatController.isFirst = false;
          }
          chatAIUtils.chatController.show(chatAIUtils.addonBar.frame)
          // if (!chatAIUtils.notifyController.view.hidden) {
          //   chatAIUtils.notifyController.hide()
          //   chatAIUtils.notifyController.notifyTimer.invalidate()
          // }
          // chatAIUtils.chatController.view.hidden = false
        } else {
            // chatAIUtils.chatController.view.hidden = true;
          chatAIUtils.chatController.hide(chatAIUtils.addonBar.frame)
          // MNUtil.refreshAddonCommands()
          return;
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          MNUtil.studyView.becomeFirstResponder(); // For dismiss keyboard on iOS
        });

        if (!chatAIUtils.chatController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
      },
      executePrompt: async function (promptKey) {
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        try {
          let selection = MNUtil.currentSelection
          if (selection.onSelection) {
            chatAIUtils.notifyController.text = selection.text
            chatAIUtils.notifyController.noteid = undefined
          }else{
            chatAIUtils.notifyController.noteid = chatAIUtils.getFocusNote().noteId
          }

          chatAIUtils.chatController.ask(promptKey)
        } catch (error) {
          chatAIUtils.addErrorLog(error, "executePrompt")
        }
      },
      toggleTrigger: async function (params) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        let trigger = !chatAIConfig.config.autoAction
        MNUtil.showHUD(trigger?"✅  Enable trigger":"❌  Disable trigger")
        chatAIConfig.config.autoAction = trigger
        chatAIConfig.save('MNChatglm_config')
        MNUtil.refreshAddonCommands()
      },
      openSideBar: async function (params) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        if (chatAIUtils.isMN3()) {
          MNUtil.showHUD("Only available in MN4")
          return
        }
        if (!chatAIUtils.sideOutputController) {
          try {
            chatAIUtils.sideOutputController = sideOutputController.new();
            MNUtil.toggleExtensionPanel()
            MNExtensionPanel.show()
            MNExtensionPanel.addSubview("chatAISideOutputView", chatAIUtils.sideOutputController.view)
            let panelView = MNExtensionPanel.view
            chatAIUtils.sideOutputController.view.hidden = false
            chatAIUtils.sideOutputController.view.frame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
            chatAIUtils.sideOutputController.currentFrame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
            // MNUtil.toggleExtensionPanel()
          } catch (error) {
            chatAIUtils.addErrorLog(error, "openSideBar")
          }
        }else{
          MNExtensionPanel.show("chatAISideOutputView")
        }
        chatAIUtils.sideOutputController.openChatView(false)
      },
      toggleWindowLocation: function (origionalLoc) {
        if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
        try {
        if (origionalLoc === 1) {
          chatAIConfig.config.notifyLoc = 0
          if (chatAIUtils.chatController.windowLocationButton) {
            chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Left",0)
          }
        }
        if (origionalLoc === 0) {
          chatAIConfig.config.notifyLoc = 1
          if (chatAIUtils.chatController.windowLocationButton) {
            chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Right",0)
          }
        }
        chatAIConfig.save("MNChatglm_config")
        if (!chatAIUtils.notifyController.view.hidden) {
          chatAIUtils.notifyController.show(chatAIConfig.config.notifyLoc,false,true)
        }
        } catch (error) {
          chatAIUtils.addErrorLog(error, "toggleWindowLocation")
        }
      },
      toggleAddon: async function (button) {
        let self = getMNChatglmClass()
//         try {
          
// let text = `
// 当然可以，以下是该卡片内容的分点解释：

// ### 标题

// **Li; Unraveling the roles of jet streams on the unprecedented hot July in Western Europe in 2022; 2024**

// - **Li**: 可能是研究的主要作者或研究团队的姓氏。
// - **Unraveling the roles of jet streams**: 揭示急流在某一事件中的角色。
// - **Unprecedented hot July in Western Europe in 2022**: 2022年西欧前所未有的炎热7月。
// - **2024**: 研究发表或完成的年份。

// ### 内容

// 1. **背景描述**

//    - **Western Europe experienced an unprecedentedly hot July in 2022**: 2022年，西欧经历了前所未有的炎热7月。
//    - **Significantly impacted ecosystems and society**: 这一事件对生态系统和社会产生了重大影响。
// 2. **研究方法**

//    - **Observational and numerical modeling study**: 通过观测和数值模拟研究。
// 3. **研究发现**

//    - **Influenced by anomalous North Atlantic and Eurasian jet streams**: 这一事件受到异常的北大西洋和欧亚急流的影响。
//    - **Northeastward shift of the North Atlantic jet stream**: 北大西洋急流向东北方向偏移。
//      - **Driven by sea surface temperature gradients**: 由海表温度梯度驱动。
//    - **Curving of the Eurasian jet stream**: 欧亚急流弯曲。
//      - **Affected by rainfall anomalies in Pakistan**: 受巴基斯坦降雨异常影响。
//    - **Enhanced atmospheric subsidence over western Europe**: 增强了西欧上空的大气下沉。
// 4. **研究结论**

//    - **Crucial role of the synergistic behavior of the North Atlantic and Eurasian jet streams**: 北大西洋和欧亚急流的协同行为在驱动西欧极端高温中起关键作用。
// 5. **未来预测**

//    - **CMIP6 climate model projections**: CMIP6气候模型预测。
//    - **Under the SSP585 scenario**: 在SSP585情景下。
//    - **Similar jet stream configurations could lead to even more intense extreme temperatures**: 类似的急流配置可能导致更强烈的极端温度。
//      - **(~7.02 ± 0.61 °C) compared to the current climatological mean**: 比当前的气候平均值高出约7.02 ± 0.61 °C。

// ### 总结

// 这张卡片概述了一项研究，该研究揭示了2022年西欧极端高温事件的成因，特别是北大西洋和欧亚急流的作用，并预测在未来气候情景下，类似的急流配置可能导致更严重的极端高温事件。




// `
// // text= `### 1. 背景条件

// // - **_jet stream exit region_**: 喷流出口区域，这是描述大气环流中的一个特定区域。
// // - **$\\frac{d\\vec{v}_{g}}{dt}<0$**: 表示在这个区域中，地转风速随时间的变化率为负，即地转风速在减小。`
//         let ast = chatAIUtils.markdown2AST(text)
//         MNUtil.copy(ast)
//         MNUtil.undoGrouping(()=>{
//           chatAIUtils.AST2Mindmap(MNNote.getFocusNote(),ast)
//         })
//         return
// // let tem = MNUtil.readText(chatAIConfig.mainPath+"/res.json")
// // let res = chatAIUtils.parseResponse(tem, true)
// // MNUtil.copy(res)
// // MNUtil.copy(chatAIConfig.mainPath+"/res.json")
//         } catch (error) {
//           chatAIUtils.addErrorLog(error, "copy")
//         }
// return
        if (!chatAIUtils.addonBar) {
          chatAIUtils.addonBar = button.superview.superview
        }
        // MNUtil.mindmapView.setZoomScaleAnimated(1.,true)
        if (!chatAIUtils.addonButton) {
          chatAIUtils.addonButton = button
        }
        let buttonFrame = chatAIUtils.addonButton.convertRectToView(chatAIUtils.addonButton.bounds,MNUtil.studyView);
        let beginFrame
        if (buttonFrame.x <120) {
          beginFrame = MNUtil.genFrame(buttonFrame.x+40, buttonFrame.y, 40, 40)
        }else{
          beginFrame = MNUtil.genFrame(buttonFrame.x-300, buttonFrame.y, 40, 40)
        }
        var commandTable = [
          {title:'⚙️   Setting',object:self,selector:'openSetting:',param:[1,2,3]},
          {title:'🤖   Float Window',object:self,selector:'openFloat:',param:beginFrame},
          {title:'💬   Chat Mode',object:self,selector:'openSideBar:',param:[1,3,2]},
          {title:'🔄   Manual Sync',object:self,selector:'syncConfig:',param:[1,2,3]},
          {title:'↔️   Location: '+(chatAIConfig.config.notifyLoc?"Right":"Left"),object:self,selector:"toggleWindowLocation:",param:chatAIConfig.config.notifyLoc}
        ];
        let trigger = chatAIConfig.getConfig("autoAction") ? "✅":"❌"
        commandTable.push({title:trigger+'   Trigger',object:self,selector:'toggleTrigger:',param:[1,2,3]})
    let promptKeys = chatAIConfig.config.promptNames
    if (promptKeys.length > 5) {
      promptKeys = promptKeys.slice(0,5)
    }
    let promptTable = promptKeys.map(key=>{
      return {title:"🚀   "+chatAIConfig.prompts[key].title,object:self,selector:'executePrompt:',param:key}
    })
    commandTable = commandTable.concat(promptTable)
    if (chatAIUtils.addonBar.frame.x < 100) {
      self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,200,4)
    }else{
      self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,200,0)
    }
    return
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: async function () {// Window disconnect 在插件页面关闭插件和删除插件
        if (typeof MNUtil === 'undefined') return
        // try {
        let confirm = await MNUtil.confirm("MN ChatAI\nRemove all config?", "是否删除所有配置？")
        if (confirm) {
          MNUtil.showHUD("[MN ChatAI] Remove config",5)
          chatAIConfig.remove("MNChatglm_prompts")
          chatAIConfig.remove("MNChatglm_knowledge")
          chatAIConfig.remove("MNChatglm_config")
          chatAIConfig.remove("MNChatglm_fileId")
          chatAIConfig.remove("MNChatglm_dynamicPrompt")
          chatAIConfig.remove("MNChatglm_builtInKeys")
        }
        // } catch (error) {
        //   showHUD(error)
        // }
      },

      applicationWillEnterForeground: function () {
        if (chatAIConfig.autoImport(true)) {
          chatAIConfig.import(false)
        }
        // if (chatAIUtils.chatController && !chatAIUtils.chatController.view.hidden) {
        //   let studyFrame = MNUtil.studyView.bounds
        //   let currentFrame = chatAIUtils.chatController.currentFrame
        //   if (!currentFrame) {
        //     return
        //   }
        //   if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
        //     currentFrame.x = studyFrame.width-currentFrame.width*0.5              
        //   }
        //   if (currentFrame.y >= studyFrame.height) {
        //     currentFrame.y = studyFrame.height-20              
        //   }
        //   chatAIUtils.chatController.view.frame = currentFrame
        //   chatAIUtils.chatController.currentFrame = currentFrame
        // }
      },

      applicationDidEnterBackground: function () {
        // MNUtil.copy("back")
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );
  /**
   * 
   * @param {string} selector 
   * @param {string} name 
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.addObserver = function (selector,name) {
    NSNotificationCenter.defaultCenter().addObserverSelectorName(this, selector, name);
  }
  /**
   * 
   * @param {string[]} names
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.removeObservers = function (names) {
    names.forEach(name=>{
      NSNotificationCenter.defaultCenter().removeObserverName(self, name);
    })
  }
  MNChatglmClass.prototype.checkShouldProceed = function (text,colorIndex = -1, param = "") {
    if (!chatAIUtils.chatController.view.window || !chatAIConfig.config.autoAction) {
      // MNUtil.showHUD("message1")
      return false;
    }
    if (param !== "" && !chatAIConfig.config[param]) {
      // MNUtil.showHUD("message2")
      return false
    }
    //聊天模式下禁用
    if (chatAIUtils.notifyController.onChat) {
      // MNUtil.showHUD("message3")
      return false
    }
    if (!chatAIUtils.chatController.view.hidden) {
      //网页模式下不会使用API模式
      // MNUtil.showHUD("message4")
      return false
    }
    //如果提供了颜色则根据颜色判断
    if (colorIndex !== -1 && !chatAIConfig.getConfig("colorConfig")[colorIndex]) {
      // showHUD("should prevent")
      // MNUtil.showHUD("message5")
      return false
    }
    if (chatAIConfig.config.ignoreShortText && chatAIUtils.countWords(text) < 10) {
      // MNUtil.showHUD("message"+chatAIUtils.countWords(text))
      // MNUtil.copy(text)
      return false
    }
    return true
  }
  /**
   * 
   * @param {*} dynamicFrame 
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.checkDynamicController = async function (dynamicFrame,fullWindow = false,animate = true) {
    if (!chatAIUtils.dynamicController) {
      chatAIUtils.initDynamicController()
      chatAIUtils.dynamicController.mainPath = mainPath;
      chatAIUtils.dynamicController.firstFrame = dynamicFrame
      chatAIUtils.dynamicController.view.hidden  = true
    }
    if (!chatAIConfig.config.dynamic) {
      chatAIUtils.dynamicController.view.hidden = true
      return
    }

    if (chatAIUtils.dynamicController.pinned) {
      chatAIUtils.dynamicController.view.hidden = false
      return
    }
    // if (chatAIUtils.dynamicController.view.hidden) {
    //   chatAIUtils.dynamicController.view.layer.opacity = 0
    //   chatAIUtils.dynamicController.view.hidden = false
    //   chatAIUtils.dynamicController.setLayout(dynamicFrame)
    // }
    chatAIUtils.dynamicController.onClick = false
    return new Promise((resolve, reject) => {
      chatAIUtils.dynamicController.setLayout(dynamicFrame).then(()=>{
        chatAIUtils.dynamicController.view.hidden = false
        if (fullWindow) {
          chatAIUtils.dynamicController.openInput()
          chatAIUtils.dynamicController.pinned = true
        }
        resolve()
      })
    })
  }
  MNChatglmClass.prototype.init = function(mainPath){ 
  try {
    if (!this.initialized) {
      chatAIUtils.init(mainPath)
      chatAIConfig.init(mainPath)
      this.initialized = true
    }
    chatAIConfig.checkCloudStore()
  } catch (error) {
    chatAIUtils.addErrorLog(error, "init")
  }  
  }
  MNChatglmClass.prototype.checkUpdate = async function () {
    let success = await chatAIConfig.readCloudConfig(false)
    if (success) {
      self.chatController.refreshLastSyncTime()
    }
  }
  return MNChatglmClass;
};