  window.MathJax = {
    tex: {
      inlineMath: [['$', '$'], ['\\(', '\\)']]
    },
    svg: {
      fontCache: 'global'
    }
  };
function getTop() {
  var element = document.getElementsByClassName("vditor")[0]
  var position = element.getBoundingClientRect();

  // 获取文档的滚动位置
  var scrollLeft = window.pageXOffset || document.documentElement.scrollLeft;
  var scrollTop = window.pageYOffset || document.documentElement.scrollTop;

  // 计算相对于文档的位置
  var docPosition = {
      top: position.top + scrollTop,
      left: position.left + scrollLeft
  };
  return docPosition.top
}
function scrollToBottom() {
  const scrollHeight = document.body.scrollHeight; // 页面的总高度
  const clientHeight = document.documentElement.clientHeight; // 可视区域的高度
  const scrollTop = document.documentElement.scrollTop || document.body.scrollTop; // 当前滚动的位置

  // 判断是否已经滚动到底部
  if (scrollHeight - (scrollTop + clientHeight) > 1) {
    window.scrollTo(0, scrollHeight); // 滚动到底部
  }
}



async function setResponse(resEncoded) {
  let res = JSON.parse(decodeURIComponent(resEncoded))
  let funcResponse = res.funcResponse ?? ""
  funcResponse = funcResponse.trim()
  let reasoningResponse = res.reasoningResponse ?? ""
  reasoningResponse = reasoningResponse.trim()
  let scrollToBottom = res.scrollToBottom ?? false
  let response = res.response ?? ""
  response = response.trim()
  let otherEle = document.getElementById("other")
  if (reasoningResponse && preReasoning !== reasoningResponse) {
    let reasoningEle = document.getElementById("reasoningResponse")   
    let collapsibleEle = document.getElementsByClassName("collapsible-content")[0]
    //判断reasoningEle是否存在
    if (!reasoningEle) {
      reasoningBegin = Date.now()
      reasoningEle = document.createElement("div")
      reasoningEle.setAttribute("id","reasoningResponse")
      otherEle.append(reasoningEle)
      reasoningEle.innerHTML = `<div class="collapsible-header" onclick="toggleCollapse(this)">
        <span class="thinkingTitle">🤔 Thinking...</span>
        <span class="toggle-icon" onclick="copyReasoningContent(this)">Copy</span></div><div class="collapsible-content"></div>`
      collapsibleEle = document.getElementsByClassName("collapsible-content")[0]
      collapsibleEle.style.maxHeight = '270px';
      collapsibleEle.style.padding = '10px';
        // document.querySelectorAll('.collapsible-content').forEach(item => {
        //     item.style.maxHeight = '170px';
        //     item.style.padding = '10px';
        // });
    }else if (!reasoningBegin) {
      reasoningBegin = Date.now()
    }

    collapsibleEle.innerHTML=reasoningResponse
    reasoningEle.querySelector('.thinkingTitle').textContent = `🤔 Thinking... (${((Date.now() - reasoningBegin)/1000).toFixed(1)}s)`
    // reasoningEle.innerHTML=reasoningResponse
    preReasoning = reasoningResponse
    //滚动到底部
    // reasoningEle.scrollTo(0,reasoningEle.scrollHeight)
    collapsibleEle.scrollTo(0,collapsibleEle.scrollHeight)
    notifyRefreshHeight()
  }
  if (funcResponse && preFunc !== funcResponse) {
    collapse()
    let funcResponseEle = document.getElementById("funcResponse")
    if (!funcResponseEle) {
      funcResponseEle = document.createElement("div")
      funcResponseEle.setAttribute("id","funcResponse")
      otherEle.append(funcResponseEle)
    }
    funcResponseEle.innerHTML=funcResponse
    preFunc = funcResponse
    notifyRefreshHeight()
  }
  if (!response) {
    if (preContent) {
      // tem.innerHTML = ""
      preContent = ""
      // notifyRefreshHeight()
      // Vditor.md2html(tem,"",option).then((html)=>{
      //   tem.innerHTML = html
      // })
      Vditor.preview(tem,"",option)
    }
  }else if (preContent !== response) {
    collapse()
    // let html = await Vditor.md2html(response,option)
    // tem.innerHTML = html
    // preContent = response
    // if (scrollToBottom) {
    //   scrollToBottom()
    // }
    // notifyRefreshHeight()
    Vditor.preview(tem,response,option)
    preContent = response
    // if (scrollToBottom) {
    //   scrollToBottom()
    // }
  }else{
    notifyRefreshHeight()
  }
  notifyRefreshHeight()

  // return document.body.scrollHeight
}

function setRealResponse(resEncoded) {
  let response = decodeURIComponent(resEncoded).trim()
  if (!response) {
    if (preContent) {
      Vditor.preview(tem,"",option)
      preContent = ""
    }
  }else if (preContent !== response) {
    collapse()
    Vditor.preview(tem,response,option)
    preContent = response
    // scrollToBottom()
  }
}
  /**
   * 获取当前选中的text/html
   * */
  function getCurrentSelect(){
    // let selectedHtml = editor.getSelection()
    let selectionObj = null, rangeObj = null;
    let selectedText = "", selectedHtml = "";

    // 处理兼容性
    if(window.getSelection){
      // 现代浏览器
      // 获取text
      selectionObj = window.getSelection();

      //  获取html
      rangeObj = selectionObj.getRangeAt(0);
      var docFragment = rangeObj.cloneContents();
      var tempDiv = document.createElement("div");
      tempDiv.appendChild(docFragment);
      selectedHtml = tempDiv.innerHTML;
    } else if(document.selection){
        // 非主流浏览器IE
        selectionObj = document.selection;
        rangeObj = selectionObj.createRange();
        selectedHtml = rangeObj.htmlText;
    }
    return editor.html2md(selectedHtml);
  };
  function createAudioElement(divId) {
    // 获取指定的div元素
    var div = document.getElementById(divId);
    div.style = "height:30px"
    if (!div) {
        console.error('Div with id ' + divId + ' not found.');
        return;
    }

    // 创建audio元素
    var audio = document.createElement('audio');
    audio.controls = true;
    audio.id = 'audioPlayer';
    // 将audio元素和fallback文本添加到div中
    div.appendChild(audio);
  }
function triggerKey(key,code,keyCode,metaKey=false,shiftKey=false,altKey=false) {
  var event = new KeyboardEvent('keydown', {
    key: key,
    code: code,
    keyCode: keyCode,
    which: keyCode,
    ctrlKey: false, // 在Windows上是true，在macOS上是metaKey: true
    metaKey: metaKey, // 在macOS上使用metaKey来表示Cmd键
    shiftKey: shiftKey,
    altKey: altKey,
    bubbles: true,
    cancelable: true
  });
  document.getElementsByClassName("vditor-reset")[0].dispatchEvent(event)
}
function copyToClipboard(text) {
  window.location.href = "nativeCopy://content="+encodeURIComponent(text);
}
function copyReasoningContent(header) {
  event.stopPropagation()
  let collapsibleEle = document.getElementsByClassName("collapsible-content")[0]
  copyToClipboard(collapsibleEle.textContent)
  // console.log(collapsibleEle.textContent);
}
function notifyRefreshHeight() {
  scrollToBottom()
  window.location.href = "editorheight://content="+document.body.scrollHeight;
}
function speech(encodedText,voice="male-qn-qingse",key,group = '1782363907101311578',speed=1.0,auto=false) {
    function hexToBlob(hex) {
      const bytes = new Uint8Array(hex.length / 2);
      for (let i = 0; i < hex.length; i += 2) {
        bytes[i / 2] = parseInt(hex.substr(i, 2), 16);
      }
      const blob = new Blob([bytes.buffer], { type: "audio/mpeg" }); 
      return blob;
    }
      // 使用函数
        const apiKey = 'eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJHcm91cE5hbWUiOiLmnpfnq4vpo54iLCJVc2VyTmFtZSI6Iuael-eri-mjniIsIkFjY291bnQiOiIiLCJTdWJqZWN0SUQiOiIxNzgyMzYzOTA3MTA5NzAwMTg2IiwiUGhvbmUiOiIxMzEyODU4OTM1MSIsIkdyb3VwSUQiOiIxNzgyMzYzOTA3MTAxMzExNTc4IiwiUGFnZU5hbWUiOiIiLCJNYWlsIjoiMTUxNDUwMTc2N0BxcS5jb20iLCJDcmVhdGVUaW1lIjoiMjAyNC0xMS0xMCAyMjo1MToxMCIsImlzcyI6Im1pbmltYXgifQ.DyygSUMVOJtV-ui9QXFVb7musUhhHJuVgXwCU2aQvZ7XZQdevvzOzZZLICBgy2lA0ItwvYCp3JaDvY_e3swqls0NB3asi-bpk_NwLqguXauCnwG1_tdAKTLEUPT2OgvuLTiVxBdymjaBm8_aQOkWmRukz3M28L3tvpxNpkEGhbnM4nP0ZXHcajHV6KYDzN2brkDiVjNz2AIM0vE7RPHbSdbjLCS9iE7SOysQvsmmM_I7Ovy6vtvJZyaliNQBbGjtGYD-KE5F_so5w8e9fvFCOraqhYpQR-2bmpnFM8l0Bi3qPe_5v-P5lAIELZWCHOhOt0gbQq9z2VylUg5y3icVrA';
        group = '1782363907101311578'
        let text = decodeURIComponent(encodedText)
        createAudioElement('audioDiv');
        var myHeaders = new Headers();
        myHeaders.append("Authorization", "Bearer "+apiKey);
        myHeaders.append("User-Agent", "Apifox/1.0.0 (https://apifox.com)");
        myHeaders.append("Content-Type", "application/json");
        const url = `https://api.minimax.chat/v1/t2a_v2?GroupId=${group}`;

        var raw = JSON.stringify({
           "model": "speech-01-turbo",
           "text": text,
            "voice_setting": {
                "voice_id": voice,
                "speed": speed,
                "vol": 1.0,
                "pitch": 0
            },
            "audio_setting": {
                "audio_sample_rate": 32000,
                "bitrate": 128000,
                "format": "mp3",
                "channel": 1
            }
        });

        var requestOptions = {
           method: 'POST',
           headers: myHeaders,
           body: raw,
           redirect: 'follow'
        };
        fetch(url, requestOptions)
           .then(response => response.json())
           .then((res) => {
              try {
                

              const blob = hexToBlob(res.data.audio)
              const blobUrl = URL.createObjectURL(blob);
               var audioPlayer = document.getElementById('audioPlayer');
               var source = document.createElement('source');
               source.src = blobUrl;
               source.type = 'audio/mpeg';
               audioPlayer.src = blobUrl
               audioPlayer.appendChild(source);
               audioPlayer.load();
               if (auto) {
                audioPlayer.play()
               }
              } catch (error) {
                document.getElementById('funcResponse').innerText = error.toString()
              }
           })
           .catch(error => console.log('error', error));
    }
function extractTitleAndTime(text) {
    // 正则表达式匹配标题和时间
    const regex = /(.*)（发布时间：(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})）/;
    const match = text.match(regex);
    
    if (match) {
        const title = match[1].trim();
        const time = match[2].trim();
        return [title, time];
    } else {
        return [text.trim()];
    }
}
    function renderSearchResults(resultsEncoded) {
      let results = JSON.parse(decodeURIComponent(resultsEncoded))
      let otherEle = document.getElementById("other")
      let container = document.getElementById("search-results")
      if (!container) {
        container = document.createElement("div")
        container.setAttribute("id","search-results")
        otherEle.append(container)
      }else{
        container.innerHTML = ''; // 清空现有内容
      }
        results.forEach(result => {
            const resultDiv = document.createElement('div');
            resultDiv.className = 'search-result';
            const title = document.createElement('h2');
            let titles = extractTitleAndTime(result.title);
            title.innerHTML = `<a href="${result.link}" target="_blank">${titles[0]}</a>`;
            const content = document.createElement('p');
            content.textContent = result.content.slice(0,200)+"...";
            resultDiv.appendChild(title);
            const media = document.createElement('p');
            if (result.media) {
              media.innerHTML = `<img src="${result.icon}" alt="${result.media}"> ${result.media}`;
              if (titles.length > 1) {
                media.innerHTML += " | "+titles[1];
              }
            }
            resultDiv.appendChild(media);
            resultDiv.appendChild(content);
            container.appendChild(resultDiv);
        });
    }
    function collapse() {
        let collapsibleEle = document.getElementsByClassName("collapsible-content")[0]
        // 切换当前项
        if (collapsibleEle?.style.maxHeight) {
            // 切换所有折叠项
            collapsibleEle.style.maxHeight = null;
            collapsibleEle.style.padding = null;
            let reasoningEle = document.getElementById("reasoningResponse")   
            reasoningEle.querySelector('.thinkingTitle').textContent = `✅ Finished Thinking  (${((Date.now() - reasoningBegin)/1000).toFixed(1)}s)`

        }
    }
    function toggleCollapse(header) {
        const content = header.nextElementSibling;
        const isOpen = content.style.maxHeight;
        let collapsibleEle = document.getElementsByClassName("collapsible-content")[0]

        // 切换当前项
        if (!isOpen) {
            collapsibleEle.style.maxHeight = '270px';
            collapsibleEle.style.padding = '10px';
            // document.querySelectorAll('.toggle-icon').forEach(icon => {
            //     icon.textContent = '▼';
            // });
            // content.style.maxHeight = content.scrollHeight + "px";
            // header.querySelector('.toggle-icon').textContent = '▲';
        }else{
            // 切换所有折叠项
            collapsibleEle.style.maxHeight = null;
            collapsibleEle.style.padding = null;
            // document.querySelectorAll('.toggle-icon').forEach(icon => {
            //     icon.textContent = '▲';
            // });
        }
    }