/** @return {chatglmController} */
const getChatglmController = ()=>self
var chatglmController = JSB.defineClass('chatglmController : UIViewController', {
  viewDidLoad: function() {
    try {
    let self = getChatglmController()
    self.init()
    self.view.frame = {x:50,y:50,width:chatAIUtils.getWidth(),height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    if (!self.settingView) {
      self.createSettingView()
    }
    self.settingViewLayout()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false

    self.createButton("moveButton","moveButtonTapped:")
    self.moveButton.clickDate = 0
    MNButton.setColor(self.moveButton, "#3a81fb",0.5)

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    // self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.promptSaveButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    // self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    // self.settingController.view.hidden = false
    } catch (error) {
      chatAIUtils.addErrorLog(error, "viewDidLoad")
      // MNUtil.copy(error)

    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  try {
    let self = getChatglmController()
    // let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 16,};
    height = height-36
    self.settingViewLayout()
    self.refreshLayout()
  } catch (error) {
    chatAIUtils.addErrorLog(error, "viewWillLayoutSubviews")
  }

  },
  moveButtonTapped: async function (button) {
    if (chatAIConfig.onSync) {
      var commandTable = [
        {title:'❌ Stop Current Sync',object:self,selector:'stopSync:',param:[1,2,3]}
      ];
      self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,200,1)
    }
    return
  },
  stopSync:function (params) {
    self.checkPopover()
    chatAIConfig.setSyncStatus(false,false)
    MNUtil.showHUD("Stop Current Sync")
  },
  openChatView: function (params) {
    self.checkPopover()
    chatAIUtils.notifyController.preFuncResponse = ""
    chatAIUtils.notifyController.onChat = true
    chatAIUtils.notifyController.openChatView(false)
    chatAIUtils.notifyController.beginNotification("Chat")
  },
  changeSearchOrder: function(sender) {
    let searchOrder = chatAIConfig.config.searchOrder
    let orderNumber = chatAIConfig.getOrderNumber(searchOrder)
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3,4],checked:orderNumber =="1234"},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2,4],checked:orderNumber=="1324"},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3,4],checked:orderNumber=="2134"},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1,4],checked:orderNumber=="2314"},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2,4],checked:orderNumber=="3124"},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1,4],checked:orderNumber=="3214"},
      {title:'Markdown → Title → Excerpt → Comment ',object:self,selector:'setSearchOrder:',param:[4,1,2,3],checked:orderNumber=="4123"},
      {title:'Markdown → Title → Comment → Excerpt ',object:self,selector:'setSearchOrder:',param:[4,1,3,2],checked:orderNumber=="4132"},
      {title:'Markdown → Excerpt → Title → Comment ',object:self,selector:'setSearchOrder:',param:[4,2,1,3],checked:orderNumber=="4213"},
      {title:'Markdown → Excerpt → Comment → Title ',object:self,selector:'setSearchOrder:',param:[4,2,3,1],checked:orderNumber=="4231"},
      {title:'Markdown → Comment → Title → Excerpt ',object:self,selector:'setSearchOrder:',param:[4,3,1,2],checked:orderNumber=="4312"},
      {title:'Markdown → Comment → Excerpt → Title ',object:self,selector:'setSearchOrder:',param:[4,3,2,1],checked:orderNumber=="4321"}
    ];
    // self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250)
    self.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,400,1)
  },
  setSearchOrder:function (order) {
    self.checkPopover()
    chatAIConfig.config.searchOrder = order
    self.orderButton.setTitleForState(chatAIConfig.getOrderText(),0)
    chatAIConfig.save("MNChatglm_config")
  },
  changeSyncSource: function (sender) {
    let self = getChatglmController()
    let syncSource = chatAIConfig.getConfig("syncSource")
    let selector = 'setSyncSource:'
    var commandTable = [
        self.tableItem('❌  None', selector, 'None',syncSource =='None'),
        self.tableItem('☁️  iCloud', selector, 'iCloud',syncSource =='iCloud'),
        self.tableItem('☁️  MNNote', selector, 'MNNote',syncSource =='MNNote'),
        self.tableItem('☁️  Cloudflare R2', selector, 'CFR2',syncSource =='CFR2'),
        self.tableItem('☁️  InfiniCloud', selector, 'Infi',syncSource =='Infi'),
        self.tableItem('☁️  Webdav', selector, 'Webdav',syncSource =='Webdav')
    ]
    self.popover(sender, commandTable,200,1)
  },
  setSyncSource: async function (source) {
    let self = getChatglmController()
    self.checkPopover()
    let currentSource = chatAIConfig.getConfig("syncSource")
    if (currentSource === source) {
      return
    }
    chatAIConfig.setSyncStatus(false)
    // self.configNoteIdInput.hidden = (source === "iCloud")
    // self.focusConfigNoteButton.hidden = (source === "iCloud")
    // self.clearConfigNoteButton.hidden = (source === "iCloud")
    // self.pasteConfigNoteButton.hidden = (source === "iCloud")
    let file
    switch (source) {
      case "iCloud":
        // MNButton.setTitle(self.exportConfigButton, "Export to iCloud")
        // MNButton.setTitle(self.importConfigButton, "Import from iCloud")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "CFR2":
        file = chatAIConfig.getConfig("r2file") ?? ""
        // MNButton.setTitle(self.exportConfigButton, "Export to R2")
        // MNButton.setTitle(self.importConfigButton, "Import from R2")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "Infi":
        file = chatAIConfig.getConfig("InfiFile") ?? ""
        // MNButton.setTitle(self.exportConfigButton, "Export to Infini")
        // MNButton.setTitle(self.importConfigButton, "Import from Infini")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "Webdav":
        file = chatAIConfig.getConfig("webdavFile") ?? ""
        // MNButton.setTitle(self.exportConfigButton, "Export to Webdav")
        // MNButton.setTitle(self.importConfigButton, "Import from Webdav")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "MNNote":
        self.configNoteIdInput.text = chatAIConfig.getConfig("syncNoteId")
        self.focusConfigNoteButton.hidden = false
        // MNButton.setTitle(self.exportConfigButton, "Export to Note")
        // MNButton.setTitle(self.importConfigButton, "Import from Note")
        MNButton.setTitle(self.focusConfigNoteButton, "Focus")
        break;
      default:
        break;
    }
    chatAIConfig.config.syncSource = source
    MNButton.setTitle(self.syncSourceButton, "Sync Config: "+chatAIConfig.getSyncSourceString(),undefined,true)
    chatAIConfig.save("MNChatglm_config",true)
    self.refreshView("syncView")
  },
  changeSource: function(sender) {
    let self = getChatglmController()
    // if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let source = chatAIConfig.config.source
    let selector = 'setSource:'
    var commandTable
    if (chatAIUtils.isActivated()) {
      commandTable = [
        self.tableItem('💡  Built-in', selector,'Built-in',source =='Built-in'),
        self.tableItem('💲  Subscription', selector,'Subscription',source =='Subscription'),
        self.tableItem('💡  ChatGPT', selector,'ChatGPT',source =='ChatGPT'),
        self.tableItem('💡  ChatGLM', selector,'ChatGLM',source =='ChatGLM'),
        self.tableItem('💡  KimiChat', selector,'KimiChat',source =='KimiChat'),
        self.tableItem('🎶  Minimax', selector,'Minimax',source =='Minimax'),
        self.tableItem('🐳  Deepseek', selector,'Deepseek',source =='Deepseek'),
        self.tableItem('💡  SiliconFlow', selector,'SiliconFlow',source =='SiliconFlow'),
        self.tableItem('🐙  Github', selector,'Github',source =='Github'),
        self.tableItem('💡  Qwen', selector,'Qwen',source =='Qwen'),
        self.tableItem('🌋  Volcengine', selector,'Volcengine',source =='Volcengine'),
        self.tableItem('✴️  Claude', selector,'Claude',source =='Claude'),
        self.tableItem('✨  Gemini', selector,'Gemini',source =='Gemini'),
        self.tableItem('🎨  Custom', selector,'Custom',source =='Custom')
      ];
    }else{
      commandTable = [
        self.tableItem('💡  Built-in', selector,'Built-in',source =='Built-in'),
        self.tableItem('💡  ChatGPT', selector,'ChatGPT',source =='ChatGPT'),
        self.tableItem('💡  ChatGLM', selector,'ChatGLM',source =='ChatGLM'),
        self.tableItem('💡  KimiChat', selector,'KimiChat',source =='KimiChat'),
        self.tableItem('🎶  Minimax', selector,'Minimax',source =='Minimax'),
        self.tableItem('🐳  Deepseek', selector,'Deepseek',source =='Deepseek'),
        self.tableItem('💡  SiliconFlow', selector,'SiliconFlow',source =='SiliconFlow'),
        self.tableItem('🐙  Github', selector,'Github',source =='Github'),
        self.tableItem('💡  Qwen', selector,'Qwen',source =='Qwen'),
        self.tableItem('🌋  Volcengine', selector,'Volcengine',source =='Volcengine'),
        self.tableItem('✴️  Claude', selector,'Claude',source =='Claude'),
        self.tableItem('✨  Gemini', selector,'Gemini',source =='Gemini'),
        self.tableItem('🎨  Custom', selector,'Custom',source =='Custom')
      ];
    }
    self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200,1)
    // self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setSource: function(param) {
  let self = getChatglmController()
  try {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let source = chatAIConfig.config.source
    if (param === source) {
      return
    }
    // let viewFrame = self.view.bounds
    // let width = viewFrame.width
    chatAIConfig.config.source = param
    self.sourceButton.setTitleForState("Source: "+chatAIConfig.config.source,0)
    self.setModel(chatAIConfig.config.source)
    self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
    let allSources = chatAIConfig.allSource(true)
    let sourceIndex = allSources.indexOf(param)
    for (let i = 0; i < allSources.length; i++) {
      let buttonName = "scrollSourceButton"+i
      if (i === sourceIndex) {
        MNButton.setConfig(self[buttonName], {color:"#2c70de"})
      }else{
        MNButton.setConfig(self[buttonName], {color:"#9bb2d6"})
      }
      self[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "setSource")
  }
  },
  setSourceByButton: function (button) {
    let allSources = chatAIConfig.allSource(true)
    let sourceIndex = button.sourceIndex
    let buttonSource = allSources[sourceIndex]
    // MNUtil.copy(buttonSource)
    let self = getChatglmController()
    try {
      let source = chatAIConfig.config.source
      if (buttonSource === source) {
        return
      }
      // let viewFrame = self.view.bounds
      // let width = viewFrame.width
      chatAIConfig.config.source = buttonSource
      self.sourceButton.setTitleForState("Source: "+chatAIConfig.config.source,0)
      self.setModel(chatAIConfig.config.source)
      self.setModelButton(chatAIConfig.config.source)
      for (let i = 0; i < allSources.length; i++) {
        let buttonName = "scrollSourceButton"+i
        if (i === sourceIndex) {
          MNButton.setConfig(self[buttonName], {color:"#2c70de"})
        }else{
          MNButton.setConfig(self[buttonName], {color:"#9bb2d6"})
        }
        self[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
      }
      chatAIConfig.save("MNChatglm_config")
    } catch (error) {
      chatAIUtils.addErrorLog(error, "setSourceByButton")
    }
  },
  changeModel: function(button) {
    let self = getChatglmController()
  try {
    var commandTable
    let source = chatAIConfig.config.source
    let config = chatAIConfig.config
    let selector = 'setModel:'
    let modelNames = chatAIConfig.modelNames(source)
    let modelName = chatAIConfig.getDefaultModel(source)
    let position = 2
    switch (source) {
      case "ChatGPT":
        position = 4
        break;
      case "Subscription":
        position = 1
        break
      default:
        break;
    }
    commandTable = modelNames.map((model)=>{
      return self.tableItem("🤖  "+model, selector,model,modelName == model)
    })
    self.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,300,position)
    // self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,4)

  } catch (error) {
    chatAIUtils.addErrorLog(error, "changeModel")
  }
  },
  setModel: function (model) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    switch (chatAIConfig.config.source) {
      case "ChatGLM":
        chatAIConfig.config.chatglmModel = model
        break;
      case "Claude":
        chatAIConfig.config.claudeModel = model
        break;
      case "SiliconFlow":
        chatAIConfig.config.siliconFlowModel = model
        break;
      case "Volcengine":
        chatAIConfig.config.volcengineModel = model
        break;
      case "Github":
        chatAIConfig.config.githubModel = model
        break;
      case "ChatGPT":
        chatAIConfig.config.model = model
        break;
      case "KimiChat":
        chatAIConfig.config.moonshotModel = model
        break;
      case "Minimax":
        chatAIConfig.config.miniMaxModel = model
        break;
      case "Custom":
        chatAIConfig.config.customModelIndex = model
        break;
      case "Gemini":
        chatAIConfig.config.geminiModel = model
        break;
      case "Deepseek":
        chatAIConfig.config.deepseekModel = model
        break;
      case "Qwen":
        chatAIConfig.config.qwenModel = model
        break;
      case "Subscription":
        chatAIConfig.config.subscriptionModel = model
        break
      case "Built-in":
        break;
      default:
        MNUtil.showHUD("Unspported source: "+config.source)
        return
    }
    // chatAIConfig.defaultModel = chatAIConfig.getDefaultModel()
    MNUtil.showHUD("Model: "+model)
    self.setModel(chatAIConfig.config.source)
    // self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
  },
  saveCustomModels: function (params) {
    chatAIConfig.config.customModel = self.customModelInput.text
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Save model")
  },
  changeFunc: function (button) {
    let self = getChatglmController()
    try {
      if (!chatAIUtils.checkSubscribe(false)) {
        return
      }
      let currentFunc
      let selector
      if (self.contextButton.currentTitle === "Text") {
        // MNUtil.showHUD("dynamicFunc")
        currentFunc = chatAIConfig.getConfig("dynamicFunc")
        selector = 'setDynamicFunc:'
      }else{
        currentFunc = chatAIConfig.currentFunc
        selector = 'setFunc:'
      }
    var commandTable = [
          {title:"🛠️ All Tools",object:self,selector:selector,param:100,checked:currentFunc.length === 10},
          {title:"🔨 Set Title",object:self,selector:selector,param:0,checked:currentFunc.includes(0)},
          {title:"🔨 Add Comment",object:self,selector:selector,param:1,checked:currentFunc.includes(1)},
          {title:"🔨 Add Tag",object:self,selector:selector,param:6,checked:currentFunc.includes(6)},
          {title:"🔨 Add Child Note",object:self,selector:selector,param:7,checked:currentFunc.includes(7)},
          {title:"🔨 Copy MD Link",object:self,selector:selector,param:2,checked:currentFunc.includes(2)},
          {title:"🔨 Copy Card URL",object:self,selector:selector,param:3,checked:currentFunc.includes(3)},
          {title:"🔨 Copy Text",object:self,selector:selector,param:4,checked:currentFunc.includes(4)},
          {title:"🔨 Clear Excerpt",object:self,selector:selector,param:8,checked:currentFunc.includes(8)},
          {title:"🔨 Set Excerpt",object:self,selector:selector,param:9,checked:currentFunc.includes(9)},
          {title:"🔨 Read Doc",object:self,selector:selector,param:10,checked:currentFunc.includes(10)},
          {title:"🔨 Read Notes",object:self,selector:selector,param:11,checked:currentFunc.includes(11)},
          {title:"🔨 Read ParentNote",object:self,selector:selector,param:13,checked:currentFunc.includes(13)},
          {title:"🔨 Web Search",object:self,selector:selector,param:12,checked:currentFunc.includes(12)},
          {title:"🔨 Close",object:self,selector:selector,param:5,checked:currentFunc.includes(5)},
          {title:"❌ None",object:self,selector:selector,param:-1,checked:currentFunc.length === 0},
        ];
    self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
    
    // self.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "changeFunc")
    }
  },
  setFunc(param) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
try {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    let currentFunc = chatAIConfig.currentFunc
    switch (param) {
      case -1:
        currentFunc = []
        break;
      case 100:
        currentFunc = [0,1,2,3,4,5,6,7,8,9,10,11,12,13]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          currentFunc.push(param)
        }
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    // chatAIUtils.copyJSON(currentFunc)
    chatAIConfig.currentFunc = currentFunc
    chatAIConfig.prompts[chatAIConfig.currentPrompt].func = currentFunc
    chatAIConfig.save("MNChatglm_prompts")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  setDynamicFunc(param) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
try {
    let currentFunc = chatAIConfig.config.dynamicFunc ? chatAIConfig.config.dynamicFunc : []
    switch (param) {
      case -1://None
        currentFunc = []
        break;
      case 100://All
        currentFunc = [0,1,2,3,4,5,6,7,8,9,10,11,12,13]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          //已经选中了则去除选中状态
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          //未选中则增加
          currentFunc.push(param)
        }
        //排序
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    chatAIConfig.config.dynamicFunc = currentFunc
    chatAIConfig.save("MNChatglm_config")
} catch (error) {
  chatAIUtils.addErrorLog(error, "setDynamicFunc")
}

  },
  changePromptModel:function (button) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    try {
    let selector = 'setPromptModel:'
    let modelName = chatAIConfig.currentModel
    // MNUtil.copy(modelName)
    // MNUtil.showHUD(self.contextButton.currentTitle)
    if (self.contextButton.currentTitle === "Text") {
      modelName = chatAIConfig.getConfig("dynamicModel")
      selector = 'setDynamicModel:'
    }
    let allModels = chatAIConfig.allSource(false,true)
    var commandTable = [
      self.tableItem("Default", selector,"Default",modelName === "Default"),
      self.tableItem("Built-in", selector,"Built-in",modelName === "Built-in")
    ]
    let secondeSelector = 'changePromptModelFromSource:'
    allModels.map((m,index)=>{
      if (chatAIConfig.hasAPIKeyInSource(m)) {
        if (modelName.startsWith(m)) {
          commandTable.push(self.tableItem("👉  "+m,secondeSelector,{source:m,button:button,index:index},true))
        }else{
          commandTable.push(self.tableItem("➡️  "+m,secondeSelector,{source:m,button:button,index:index},false))

          // switch (m) {
          //   case "Deepseek":
          //     commandTable.push(self.tableItem("🐳  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          //   case "Volcengine":
          //     commandTable.push(self.tableItem("🌋  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          //   case "Gemini":
          //     commandTable.push(self.tableItem("✨  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          //   case "Subscription":
          //     commandTable.push(self.tableItem("$  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          //   case "Minimax":
          //     commandTable.push(self.tableItem("🎶  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          //   default:
          //     commandTable.push(self.tableItem("➡️  "+m,secondeSelector,{source:m,button:button,index:index},false))
          //     break;
          // }
        }
      }
    })
    self.popover(button, commandTable,220,0)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "chatglmController.changePromptModel")
    }
  },
  changePromptModelFromSource: function (params) {
  try {
    let self = getChatglmController()
    let source = params.source
    let button = params.button
    let selectIndex = params.index
    // MNUtil.showHUD("message"+selectIndex)
    self.checkPopover()
    let selector = 'setPromptModel:'
    let modelName = chatAIConfig.currentModel
    if (self.contextButton.currentTitle === "Text") {
      modelName = chatAIConfig.getConfig("dynamicModel")
      selector = 'setDynamicModel:'
    }
    let allModels = chatAIConfig.allSource(false,true)
    var commandTable = [
      self.tableItem("Default", selector,"Default",modelName === "Default"),
      self.tableItem("Built-in", selector,"Built-in",modelName === "Built-in")
    ]
    let secondSelector = 'changePromptModelFromSource:'
    let sourceModels = chatAIConfig.getAvailableModels(source)
    let widths = []
    allModels.map((m,index)=>{
      if (chatAIConfig.hasAPIKeyInSource(m)) {
        if (index === selectIndex) {
          commandTable.push(self.tableItem("👇  "+m,"",{source:m,button:button},false))
        }else if (modelName.startsWith(m)) {
          commandTable.push(self.tableItem("👉  "+m,secondSelector,{source:m,button:button,index:index},true))
        }else{
          commandTable.push(self.tableItem("➡️  "+m,secondSelector,{source:m,button:button,index:index},false))
        }
      }
    })
    let tablesToInsert = sourceModels.map(model=>{
      let m = "       🤖  "+model.split(": ")[1].trim()
      widths.push(chatAIUtils.strCode(m))
      return self.tableItem(m, selector,model,modelName === model)
    })
    commandTable.splice(selectIndex+3,0,...tablesToInsert)
    self.popover(button, commandTable,Math.max(...widths)*9+30,0)
    
  } catch (error) {
    chatAIUtils.addErrorLog(error, "changePromptModelFromSource")
  }
  },
  setPromptModel: function (model) {
    self.checkPopover()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    // let config = model.split(":")
    let promptName = chatAIConfig.prompts[chatAIConfig.currentPrompt].title
    chatAIConfig.prompts[chatAIConfig.currentPrompt].model = model
    chatAIConfig.setCurrentPrompt(chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_prompts")
    MNUtil.showHUD("Set model for "+promptName+": ["+model+"]")
  },
  setDynamicModel: function (model) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.dynamicModel = model
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set model for Dynamic: ["+model+"]")
  },
  changeActions: function (button) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    let currentAction
    let selector
    if (self.contextButton.currentTitle === "Text") {
      // MNUtil.showHUD("dynamicFunc")
      currentAction = chatAIConfig.getConfig("dynamicAction")
      selector = 'setDynamicAction:'
    }else{
      currentAction = chatAIConfig.currentAction ?? []
      selector = 'setAction:'
    }
    var commandTable = [
          {title:"🛠️ All Actions",object:self,selector:selector,param:100,checked:currentAction.length === 10},
          {title:"🔨 Set Title",object:self,selector:selector,param:0,checked:currentAction.includes(0)},
          {title:"🔨 Add Comment",object:self,selector:selector,param:1,checked:currentAction.includes(1)},
          {title:"🔨 Add Tag",object:self,selector:selector,param:6,checked:currentAction.includes(6)},
          {title:"🔨 Add Child Note",object:self,selector:selector,param:7,checked:currentAction.includes(7)},
          {title:"🔨 Copy MD Link",object:self,selector:selector,param:2,checked:currentAction.includes(2)},
          {title:"🔨 Copy Card URL",object:self,selector:selector,param:3,checked:currentAction.includes(3)},
          {title:"🔨 Copy Text",object:self,selector:selector,param:4,checked:currentAction.includes(4)},
          {title:"🔨 Clear Excerpt",object:self,selector:selector,param:8,checked:currentAction.includes(8)},
          {title:"🔨 Set Excerpt",object:self,selector:selector,param:9,checked:currentAction.includes(9)},
          {title:"🔨 Close",object:self,selector:selector,param:5,checked:currentAction.includes(5)},
          {title:"❌ None",object:self,selector:selector,param:-1,checked:currentAction.length === 0},
        ];
    self.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
  },
  setAction(param) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
try {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    let currentAction = chatAIConfig.currentAction
    switch (param) {
      case -1:
        currentAction = []
        break;
      case 100:
        currentAction = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentAction.includes(param)) {
          currentAction = currentAction.filter(func=> func!==param)
        }else{
          currentAction.push(param)
        }
        currentAction.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    // chatAIUtils.copyJSON(currentAction)
    chatAIConfig.currentAction = currentAction
    chatAIConfig.prompts[chatAIConfig.currentPrompt].action = currentAction
    chatAIConfig.save("MNChatglm_prompts")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  setDynamicAction(param) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
try {
    let currentAction = chatAIConfig.config.dynamicAction ? chatAIConfig.config.dynamicAction : []
    switch (param) {
      case -1://None
        currentAction = []
        break;
      case 100://All
        currentAction = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentAction.includes(param)) {
          //已经选中了则去除选中状态
          currentAction = currentAction.filter(func=> func!==param)
        }else{
          //未选中则增加
          currentAction.push(param)
        }
        //排序
        currentAction.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    chatAIConfig.config.dynamicAction = currentAction
    chatAIConfig.save("MNChatglm_config")
} catch (error) {
  MNUtil.showHUD(error)
}

  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  openSettingView:function () {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(chatAIConfig.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
      showHUD(error)
      
    }

    // self.view.addSubview(self.tabView)
  },
  resetConfig: async function (button) {
  try {
    let confirm = await MNUtil.confirm("MN ChatAI\nReset All Prompts?", "重置所有prompt？")
    if (confirm) {
      let self = getChatglmController()
      chatAIConfig.reset()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      if (chatAIConfig.config.dynamic) {
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
        self.dynamicButton.setTitleForState("Dynamic ✅",0)
      }else{
        self.dynamicButton.setTitleForState("Dynamic ❌",0)
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      }
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "resetConfig")
  }
  },

  toggleWindowLocation: function () {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    switch (chatAIConfig.config.notifyLoc) {
      case 1:
        chatAIConfig.config.notifyLoc = 0
        self.windowLocationButton.setTitleForState("Notification: Left",0)
        // chatAIUtils.notifyController.locationButton.setTitleForState("Left",0)
        break;
      case 0:
        chatAIConfig.config.notifyLoc = 1
        self.windowLocationButton.setTitleForState("Notification: Right",0)
        // chatAIUtils.notifyController.locationButton.setTitleForState("Right",0)
        break;
      default:
        break;
    }
    // chatAIUtils.notifyController.config = chatAIConfig.config
    chatAIConfig.save("MNChatglm_config")
  },
  toggleAutoTheme: function(){
    chatAIConfig.config.autoTheme = !chatAIConfig.getConfig("autoTheme")
    MNButton.setTitle(self.autoThemeButton, "Auto Theme: "+(chatAIConfig.getConfig("autoTheme")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
    if (chatAIConfig.config.autoTheme) {
      chatAIUtils.notifyController.checkTheme(true)
    }
  },
  toggleAutoImage: function (params) {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    chatAIConfig.config.autoImage = !chatAIConfig.getConfig("autoImage")
    MNButton.setTitle(self.autoImageButton, "Auto Select Image: "+(chatAIConfig.getConfig("autoImage")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  },
  toggleAutoClose: function (params) {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    chatAIConfig.config.autoClose = !chatAIConfig.getConfig("autoClose")
    MNButton.setTitle(self.autoCloseAfterAction, "Auto Close After Action: "+(chatAIConfig.getConfig("autoClose")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  },
  closeButtonTapped: function() {
    if (chatAIUtils.addonBar) {
      self.hide(chatAIUtils.addonBar.frame)
    }else{
      self.hide()
    }
    self.searchedText = ""
  },
  onMoveGesture:function (gesture) {
    let location = chatAIUtils.getNewLoc(gesture)
    let frame = self.view.frame
    self.view.frame = MNUtil.genFrame(location.x,location.y,frame.width,frame.height)
    self.currentFrame  = self.view.frame
    self.custom = false;
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  },
  onResizeGesture:function (gesture) {
  try {
    let baseframe = gesture.view.frame
    // let locationToBrowser = gesture.locationInView(self.view)
    // let locationToButton = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let translation = chatAIUtils.getTranslation(gesture)
    let width = translation.x-frame.x+baseframe.width
    let height = translation.y-frame.y+baseframe.height+15
    if (width <= 330) {
      width = 330
    }
    if (height <= 465) {
      height = 465
    }

    // if (translation) {
    //   MNUtil.showHUD(JSON.stringify(translation))
      // let newFrame = {x:frame.x,y:frame.y,width:frame.width+translation.x,height:frame.height+translation.y}
      // self.view.frame = newFrame
      self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
      self.currentFrame  = self.view.frame
    // }
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  onResizeGesture0:function (gesture) {
    self.custom = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = self.view.frame.height
    if (width <= 330) {
      width = 330
    }
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  },
  modelTabTapped: function (params) {
    self.switchView("modelView")
    if (chatAIConfig.config.source === "Built-in") {
      if (chatAIUtils.checkSubscribe(false,false,true)) {
        self.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
    }
  },
  triggerButtonTapped: function (params) {
    self.switchView("autoActionView")
  },
  advancedButtonTapped: function (params) {
    self.switchView("advanceView")

  },
  syncConfigTapped: function (params) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    self.switchView("syncView")
  },
  configButtonTapped: function (params) {
    self.switchView("configView")
  },
  configSystemTapped: function (button) {
    if (self.contextInput.hidden) {
      self.checkPopover()
      if (self.titleInput.editable) {
        var commandTable = [
          self.tableItem("▶️   Test", 'promptAction:', "testSystem"),
          self.tableItem("🗑️   Clear", 'promptAction:', "clearSystem")
        ]
        self.popover(button, commandTable,120,0)
        return
      }else{
        var commandTable = [
          self.tableItem("🗑️   Clear", 'promptAction:', "clearSystem")
        ]
        self.popover(button, commandTable,120,0)
        return
      }
    }
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextInput.hidden = true
    self.systemInput.hidden = false
  },
  configContextTapped: function (button) {
    if (self.systemInput.hidden) {
      self.checkPopover()
      if (self.titleInput.editable) {
        var commandTable = [
          self.tableItem("▶️   Test", 'promptAction:', "testUser"),
          self.tableItem("🗑️   Clear", 'promptAction:', "clearUser")
        ]
        self.popover(button, commandTable,120,0)
        return
      }else{
        var commandTable = [
          self.tableItem("🗑️   Clear", 'promptAction:', "clearUser")
        ]
        self.popover(button, commandTable,120,0)
        return
      }
    }
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextInput.hidden = false
    self.systemInput.hidden = true
  },
  promptSaveTapped: function (button) {
    try {
    let self = getChatglmController()
    if (self.contextButton.currentTitle === "Text") {
      chatAIConfig.dynamicPrompt.text = self.contextInput.text
      chatAIConfig.dynamicPrompt.note = self.systemInput.text
      self.contextInput.endEditing(true)
      self.systemInput.endEditing(true)
      chatAIConfig.save("MNChatglm_dynamicPrompt")
      self.showHUD("Save Dynamic prompt")
      return
    }
    // return
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<500) {
      if (MNUtil.studyMode === 3) {
        let focuseNote = chatAIUtils.getFocusNote()
        chatAIUtils.currentNoteId = focuseNote.noteId
      }
      chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
      chatAIUtils.notifyController.text = chatAIUtils.currentSelection
      if (chatAIUtils.checkCouldAsk()) {
        self.ask()
      }
    }else{
      button.clickDate = Date.now()
      // chatAIConfig.export(false)
      // let noteId = chatAIConfig.config.syncNoteId
      // let focusNote = MNUtil.getNoteById(noteId)
      // MNUtil.copy(focusNote.noteId)
      // // let noteId0 = focusNote.noteId
      let oldConfig = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      let oldJson = JSON.stringify(oldConfig)
      let config = oldConfig
      config.title = self.titleInput.text ?? ""
      config.context = self.contextInput.text ?? ""
      config.system = self.systemInput.text ?? ""
      self.contextInput.endEditing(true)
      self.systemInput.endEditing(true)
      if (oldJson === JSON.stringify(config)) {
        return
      }
      chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      MNUtil.delay(0.1).then(()=>{
        chatAIConfig.save("MNChatglm_prompts",false,false)
        self.showHUD("Save prompt: "+chatAIConfig.prompts[chatAIConfig.currentPrompt].title,2,self.view)
      })
    }
    } catch (error) {
      chatAIUtils.addErrorLog(error, "promptSaveTapped")
    }
  },
  onLongPressSavePrompt: function (gesture) {
    if (gesture.state === 1) {
      let self = getChatglmController()
      if (self.contextButton.currentTitle === "Text") {
        chatAIConfig.dynamicPrompt.text = self.contextInput.text
        chatAIConfig.dynamicPrompt.note = self.systemInput.text
        chatAIConfig.save("MNChatglm_dynamicPrompt")
        MNUtil.showHUD("Save Dynamic prompt")
        return
      }
      let config = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      config.title = self.titleInput.text ?? ""
      config.context = self.contextInput.text ?? ""
      config.system = self.systemInput.text ?? ""
      chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      MNUtil.delay(0.1).then(()=>{
        chatAIConfig.save("MNChatglm_prompts",false,false)
      })
      if (MNUtil.studyMode === 3) {
        let focuseNote = chatAIUtils.getFocusNote()
        chatAIUtils.currentNoteId = focuseNote.noteId
      }
      chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
      chatAIUtils.notifyController.text = chatAIUtils.currentSelection
      if (chatAIUtils.checkCouldAsk()) {
        self.ask()
      }
    }
  },
  saveKnowledgeButtonTapped: function (params) {
    try {
      chatAIConfig.knowledge = self.knowledgeInput.text
      chatAIConfig.save("MNChatglm_knowledge")
      MNUtil.showHUD("Save knowledge")
    } catch (error) {
      MNUtil.showHUD(error);
    }
  },
  changeTunnel: async function(sender) {
    let self = getChatglmController()
    let tunnels = await chatAIConfig.getTunnels()
    var commandTable = tunnels.map((tunnel,index)=>{
      return {title:tunnel,object:self,selector:'setTunnel:',param:index,checked:chatAIConfig.config.tunnel ==index}
    })
    self.popover(sender, commandTable,300,1)
    // self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setTunnel: async function name(param) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let tunnels = await chatAIConfig.getTunnels()
    chatAIConfig.config.tunnel = param
    self.tunnelButton.setTitleForState(tunnels[param],0)
    chatAIConfig.save("MNChatglm_config")
  },
  refreshUsage: async function (button) {
    if (button.builtIn) {
      if (chatAIUtils.checkSubscribe(false,false,true)) {
        self.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
    }else{
      let self = getChatglmController()
      MNUtil.showHUD("Fetching usage")
      let usage  = await chatAINetwork.getUsage()
      self.customUsage.setTitleForState(`Usage: ${(usage.usage/100.).toFixed(2)} / ${usage.total.toFixed(2)}`,0) 
    }
  },
  configAddTapped: function (button) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:"➕   New Prompt",object:self,selector:'improtAction:',param:"New"},
      {title:"📋   From Clipboard",object:self,selector:'improtAction:',param:"Paste"},
    ]
    self.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,190)
    return
  },
  improtAction: async function (params) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    if (Object.keys(chatAIConfig.prompts).length >= 10 && !chatAIUtils.checkSubscribe()) {
      return
    }
    let config = {}
    let prompt = {}
    let i = 0
    while (chatAIConfig.prompts["customEngine"+i]) {
      i = i+1
    }
    switch (params) {
      case "New":
        // MNUtil.showHUD("message"+Object.keys(chatAIConfig.prompts).length)
        self.titleInput.text = "New prompt"
        self.contextInput.text = "input your prompt"
        self.systemInput.text = ""
        config = {title:self.titleInput.text,context:self.contextInput.text}
        break;
      case "Paste":
        let clipboardText = MNUtil.clipboardText
        if (clipboardText && MNUtil.isValidJSON(clipboardText)) {
          prompt = JSON.parse(clipboardText)
          if (prompt.title) {
            let confirm = await MNUtil.confirm("MN ChatAI\nImport prompt ["+prompt.title+"]?", "是否导入 prompt ["+prompt.title+"]？")
            if (!confirm) {
              MNUtil.showHUD("Cancel import")
              return
            }
          }else{
            return
          }
          self.titleInput.text = prompt.title
          self.contextInput.text = prompt.context
          self.systemInput.text = prompt.system
          config = prompt
        }
      default:
        break;
    }
    let prompts = chatAIConfig.prompts
    prompts["customEngine"+i] = config
    chatAIConfig.prompts = prompts
    chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.concat(("customEngine"+i))
    self.setButtonText(chatAIConfig.config.promptNames,"customEngine"+i)
    chatAIConfig.setCurrentPrompt("customEngine"+i)
    self.refreshLayout()
    chatAIConfig.save("MNChatglm_prompts")
  },
  addVariable: function (sender) {
    let vars = ['{{!}}','{{card}}','{{cardOCR}}','{{cards}}','{{cardsOCR}}','{{parentCard}}','{{parentCardOCR}}','{{context}}','{{textOCR}}','{{userInput}}','{{knowledge}}','{{noteDocInfo}}','{{currentDocInfo}}','{{noteDocAttach}}','{{currentDocAttach}}','{{noteDocName}}','{{currentDocName}}','{{selectionText}}','{{clipboardText}}']
    var commandTable = vars.map(variable=>{
      return {title:variable,object:self,selector:'insert:',param:variable}
    })
    self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200,4)
    // let self = getChatglmController()
    // let range = self.contextInput.selectedRange
    // let pre = self.contextInput.text.slice(0,range.location)
    // let post = self.contextInput.text.slice(range.location)
    // self.contextInput.text = pre+"{{context}}"+post
    // copyJSON(range)
  },
  insert: function (variable) {
    let self = getChatglmController()
    if (!self.contextInput.hidden) {
      let range = self.contextInput.selectedRange
      let pre = self.contextInput.text.slice(0,range.location)
      let post = self.contextInput.text.slice(range.location+range.length)
      self.contextInput.text = pre+variable+post
    }
    if (!self.systemInput.hidden) {
      let range = self.systemInput.selectedRange
      let pre = self.systemInput.text.slice(0,range.location)
      let post = self.systemInput.text.slice(range.location+range.length)
      self.systemInput.text = pre+variable+post
    }
  },
  configDeleteTapped: async function (button) {
    if (Object.keys(chatAIConfig.prompts).length === 1) {
      MNUtil.showHUD("You can not clear all prompts!")
      return
    }
    let confirm = await MNUtil.confirm("MN ChatAI\nDelete this prompt?", "删除这个prompt？")
    if (confirm) {
      delete chatAIConfig.prompts[chatAIConfig.currentPrompt]
      chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.filter(item=>item !== chatAIConfig.config.currentPrompt)
      chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.refreshLayout()
      chatAIConfig.save("MNChatglm_config")
      chatAIConfig.save("MNChatglm_prompts")
    }
  },
  pasteApiKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string.trim()
    self.apiKeyInput.text = apikey
    chatAIConfig.saveApiKey(apikey)
  },
  importFromSubscription:function (params) {
    try {
    if (chatAIUtils.checkSubscribe(false)) {
      let apikey = subscriptionConfig.config.apikey
      if (!apikey.trim()) {
        MNUtil.showHUD("Empty key!")
        return
      }
      self.apiKeyInput.text = apikey
      if (subscriptionConfig.config.url) {
        self.URLInput.text = subscriptionConfig.config.url
        chatAIConfig.saveApiKey(apikey,subscriptionConfig.config.url)
      }else{
        self.URLInput.text = "https://api.feliks.top"
        chatAIConfig.saveApiKey(apikey,"https://api.feliks.top")
      }
      // MNUtil.showHUD("Import success!")
      // chatAIConfig.save('MNChatglm_config')
    }

    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleImageCompressionButton: function (params) {
    chatAIConfig.config.imageCompression = !chatAIConfig.getConfig("imageCompression")
    MNButton.setTitle(self.imageCompressionButton, "Image Compression for vision mode: "+(chatAIConfig.getConfig("imageCompression")?"✅":"❌"))
  },

  pasteURL:function (params) {
    let URL = chatAIUtils.clipboardText().trim()
    self.URLInput.text = URL
    switch (chatAIConfig.config.source) {
      case "Custom":
        chatAIConfig.config.customUrl = URL
        break;
      case "ChatGPT":
        chatAIConfig.config.url = URL.replace("/v1/chat/completions", "")
        break;
      case "Gemini":
        chatAIConfig.config.geminiUrl = URL
        break;
      default:
        MNUtil.showHUD("Unsupported source: "+chatAIConfig.config.source)
        return;
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
  },
  saveURL:function (params) {
    try {
      
    if (chatAIConfig.config.source === "Custom") {
      chatAIConfig.config.customUrl = self.URLInput.text.trim()
    }else{
      chatAIConfig.config.url = self.URLInput.text.trim()
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  saveConfig: async function (params) {
    switch (chatAIConfig.config.source) {
      case "Built-in":
        MNUtil.showHUD("Refreshing...")
        let keys = await chatAINetwork.fetchKeys0()
        if (keys) {
          chatAIConfig.keys = keys 
          if (keys.message) {
            MNUtil.showHUD(keys.message)
            chatAIConfig.save('MNChatglm_builtInKeys')
            self.refreshView("modelView")
            // self.refreshButton.setTitleForState(`1️⃣: ${keys.key0.keys.length}, 2️⃣: ${keys.key1.keys.length}, 3️⃣: ${keys.key2.keys.length}, 4️⃣: ${keys.key3.keys.length}`,0)
            return
          }
        }
        MNUtil.showHUD("error")
        return;
      case "ChatGLM":
        chatAIConfig.config.apikey = self.apiKeyInput.text.trim()
        break;
      case "Claude":
        chatAIConfig.config.claudeKey = self.apiKeyInput.text.trim()
        break;
      case "Gemini":
        chatAIConfig.config.geminiKey = self.apiKeyInput.text.trim()
        chatAIConfig.config.geminiUrl = self.URLInput.text.trim()
        break;
      case "ChatGPT":
        chatAIConfig.config.openaiKey = self.apiKeyInput.text.trim()
        chatAIConfig.config.url = self.URLInput.text.trim()
        chatAIConfig.config.customModel = self.customModelInput.text
        break;
      case "KimiChat":
        chatAIConfig.config.moonshotKey = self.apiKeyInput.text.trim()
        break;
      case "Minimax":
        chatAIConfig.config.miniMaxKey = self.apiKeyInput.text.trim()
        break
      case "Custom":
        chatAIConfig.config.customKey = self.apiKeyInput.text.trim()
        chatAIConfig.config.customUrl = self.URLInput.text.trim()
        chatAIConfig.config.customModel = self.customModelInput.text
        break
      case "SiliconFlow":
        chatAIConfig.config.siliconFlowKey = self.apiKeyInput.text.trim()
        break
      case "Volcengine":
        chatAIConfig.config.volcengineKey = self.apiKeyInput.text.trim()
        break
      case "Deepseek":
        chatAIConfig.config.deepseekKey = self.apiKeyInput.text.trim()
        break;
      case "Github":
        chatAIConfig.config.githubKey = self.apiKeyInput.text.trim()
        break;
      case "Qwen":
        chatAIConfig.config.qwenKey = self.apiKeyInput.text.trim()
        break;
      case "Subscription":
        chatAIConfig.config.customModel = self.customModelInput.text
        break;
      case "Built-in":
        break;
      default:
        MNUtil.showHUD("Unspported source: "+chatAIConfig.config.source)
        return
    }
    chatAIConfig.save('MNChatglm_config')
    MNUtil.showHUD("Save Config for ["+chatAIConfig.config.source+"]")
  },
  toggleSelected: async function (button) {
  try {
    let self = getChatglmController()
    let config = chatAIConfig.prompts[button.id]
    let temperature = config.temperature ?? 0.8
    if (button.isSelected) {
      self.checkPopover()
      var commandTable = [
        self.tableItem("▶️   Excute prompt", 'promptAction:', "Excute"),
        self.tableItem("💬   Begin Chat", 'promptAction:', "Chat"),
        self.tableItem("📄   Copy prompt", 'promptAction:', "Copy"),
        self.tableItem("🗑   Delete prompt", 'promptAction:', "Delete"),
        self.tableItem("🔝   Move to top", 'promptAction:', "Top"),
        self.tableItem("👇   Move to bottom", 'promptAction:', "Bottom"),
        self.tableItem("🌡️   Temperature: "+temperature, 'promptAction:', "changeTemperature")
      ]
      self.popover(button, commandTable,190,1)
      return
    }
    self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.titleInput.editable = true
    self.promptSaveButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    if (button.isSelected && chatAIConfig.currentPrompt === button.id) {
      return
    }
    let title = button.id
    chatAIConfig.setCurrentPrompt(title)
    self.words.forEach((entryName,index)=>{
      if (entryName === title) {
        self["nameButton"+index].isSelected = true
        self["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8);
      }else{
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
      }
    })
    if (button.isSelected) {
      self.setTextview(title)
    }
    self.SystemButton.setTitleForState("System",0)
    self.contextButton.setTitleForState("User",0)
    self.visionButton.hidden = false
    chatAIConfig.save('MNChatglm_config')
    self.settingViewLayout()

  } catch (error) {
    chatAIUtils.addErrorLog(error, "toggleSelected")
  }
  },
  promptAction: async function (params) {
    try {
      let self = getChatglmController()
      self.checkPopover()
      let promptNames = chatAIConfig.getConfig("promptNames")
      let currentPrompt = chatAIConfig.currentPrompt
      let prompt = chatAIConfig.prompts[currentPrompt]
      let vision = prompt.vision
      switch (params) {
        case "Excute":
          MNUtil.showHUD("Excute prompt: "+prompt.title)
          if (chatAIUtils.currentSelection === "") {
            MNUtil.showHUD("no text/card selected")
            return
          }
          if (chatAIUtils.checkCouldAsk()) {
            self.ask()
          }
          break;
        case "Chat":
          if (chatAIUtils.isMN3()) {
            MNUtil.showHUD("Only available in MN4")
            return
          }
          if (!chatAIUtils.sideOutputController) {
            try {
              chatAIUtils.sideOutputController = sideOutputController.new();
              MNUtil.toggleExtensionPanel()
              MNExtensionPanel.show()
              MNExtensionPanel.addSubview("chatAISideOutputView", chatAIUtils.sideOutputController.view)
              let panelView = MNExtensionPanel.view
              chatAIUtils.sideOutputController.view.hidden = false
              chatAIUtils.sideOutputController.view.frame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
              chatAIUtils.sideOutputController.currentFrame = {x:0,y:0,width:panelView.frame.width,height:panelView.frame.height}
              // MNUtil.toggleExtensionPanel()
            } catch (error) {
              chatAIUtils.addErrorLog(error, "openSideBar")
            }
          }else{
            MNExtensionPanel.show("chatAISideOutputView")
          }
          chatAIUtils.sideOutputController.openChatViewFromPrompt(currentPrompt)
          break;
        case "Copy":
          MNUtil.copy(JSON.stringify(prompt,null,2))
          MNUtil.showHUD("Copy prompt ["+prompt.title+"] to clipboard")
          break;
        case "Delete":
          if (Object.keys(chatAIConfig.prompts).length === 1) {
            MNUtil.showHUD("You can not clear all prompts!")
            return
          }
          let confirm = await MNUtil.confirm("MN ChatAI\nDelete this prompt?", "删除这个prompt？")
          if (confirm) {
            delete chatAIConfig.prompts[currentPrompt]
            chatAIConfig.config.promptNames = promptNames.filter(item=>item !== chatAIConfig.config.currentPrompt)
            chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
            self.setButtonText(chatAIConfig.config.promptNames,currentPrompt)
            self.refreshLayout()
            chatAIConfig.save("MNChatglm_config")
            chatAIConfig.save("MNChatglm_prompts")
          }
          break;
        case "Top":
          chatAIUtils.moveElement(promptNames, currentPrompt, "top")
          self.setButtonText(promptNames,currentPrompt)
          chatAIConfig.save("MNChatglm_config")
          break;
        case "Bottom":
          chatAIUtils.moveElement(promptNames, currentPrompt, "bottom")
          self.setButtonText(promptNames,currentPrompt)
          chatAIConfig.save("MNChatglm_config")
          break;
        case "changeTemperature":
          let options = [
            "🌡️  1.0",
            "🌡️  0.8",
            "🌡️  0.6",
            "🌡️  0.4",
            "🌡️  0.2",
            "🌡️  0.0"
          ]
          let temperatures = [1.0,0.8,0.6,0.4,0.2,0.0]
          let res = await MNUtil.userSelect("Select temperature", "选择温度", options)
          if (res) {
            let targetTemperature = temperatures[res-1]
            chatAIConfig.prompts[currentPrompt].temperature = targetTemperature
            MNUtil.showHUD("Change temperature to "+targetTemperature)
            chatAIConfig.save("MNChatglm_prompts")
          }
          break;
        case "testSystem":
          let system = self.systemInput.text
          if (system) {
            let opt = {noteId:MNNote.getFocusNote()?.noteId,vision:!!vision}
            let systemMessage = await chatAIUtils.render(system,opt)
            // MNUtil.confirm("System Prompt", systemMessage.slice(0, 2000))
            if (systemMessage && systemMessage.trim()) {
              MNUtil.copy(systemMessage)
              self.showHUD("Copy system message")
            }else{
              self.showHUD("❌ Empty system message")
            }
          }
          break;
        case "clearSystem":
          self.systemInput.text = ""
          self.showHUD("Clear system message")
          break
        case "testUser":
          let context = self.contextInput.text
          if (context) {
            let opt = {noteId:MNNote.getFocusNote()?.noteId,vision:!!vision}
            let contextMessage = await chatAIUtils.render(context,opt)
            if (contextMessage && contextMessage.trim()) {
              MNUtil.copy(contextMessage)
              self.showHUD("Copy context message")
            }else{
              self.showHUD("❌ Empty context message")
            }
          }
          break;
        case "clearUser":
          self.contextInput.text = ""
          self.showHUD("Clear context message")
          break
        default:
          MNUtil.showHUD("Unknown action: "	+ params)
          break;
      }
    } catch (error) {
      chatAIUtils.addErrorLog(error, "promptAction")
    }
  },
  moveForwardTapped:function (params) {
    let promptNames = chatAIConfig.getConfig("promptNames")
    chatAIUtils.moveElement(promptNames, chatAIConfig.currentPrompt, "up")
    self.setButtonText(promptNames,chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_config")
  },
  moveBackwardTapped:function (params) {
    let promptNames = chatAIConfig.getConfig("promptNames")
    chatAIUtils.moveElement(promptNames, chatAIConfig.currentPrompt, "down")
    self.setButtonText(promptNames,chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_config")
  },
  toggleAutoAction:function () {
  try {
    chatAIConfig.config.autoAction = !chatAIConfig.config.autoAction
    chatAIConfig.save('MNChatglm_config')
    self.refreshView("autoActionView")
    return
    // self.autoActionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.autoAction)
    // let title = chatAIConfig.config.autoAction ? "Enable trigger: ✅" : "Enable trigger: ❌"
    // self.autoActionButton.setTitleForState(title)
    // self.onSelectionButton.hidden = !chatAIConfig.config.autoAction
    // self.onNewExcerptButton.hidden = !chatAIConfig.config.autoAction
    // self.newExcerptTagDetection.hidden = !chatAIConfig.config.autoAction
    // self.onNoteButton.hidden = !chatAIConfig.config.autoAction
    // self.ignoreButton.hidden = !chatAIConfig.config.autoAction
    // self.delayButton.hidden = !chatAIConfig.config.autoAction

    // for (let index = 0; index < 32; index++) {
    //   self["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
    // }
    // MNUtil.refreshAddonCommands()
      } catch (error) {
      chatAIUtils.addErrorLog(error, "toggleAutoAction")
  }
  },
  toggleOnSelection:function () {
    chatAIConfig.config.onSelection = !chatAIConfig.config.onSelection
    chatAIConfig.save('MNChatglm_config')
    self.onSelectionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.onSelection)
    if (chatAIConfig.config.onSelection) {
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",.8)
      self.onSelectionButton.setTitleForState("On Selection: ✅")
    }else{
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ❌")
    }
  },
  toggleOnNote:function () {
    chatAIConfig.config.onNote = !chatAIConfig.config.onNote
    chatAIConfig.save("MNChatglm_config")

    if (chatAIConfig.config.onNote) {
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNoteButton.setTitleForState("On Note: ✅")
    }else{
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNoteButton.setTitleForState("On Note: ❌")
    }
  },
  toggleOnNewExcerpt:function () {
    chatAIConfig.config.onNewExcerpt = !chatAIConfig.config.onNewExcerpt
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.onNewExcerpt) {
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  toggleNewExcerptTagDetection:function () {
    if (!chatAIConfig.getConfig("newExcerptTagDetection") && !chatAIUtils.checkSubscribe()) {
      return
    }
    chatAIConfig.config.newExcerptTagDetection = !chatAIConfig.config.newExcerptTagDetection
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.newExcerptTagDetection) {
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ✅")
    }else{
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ❌")
    }
  },
  toggleAutoSpeech:function (params) {
    chatAIConfig.config.autoSpeech = !chatAIConfig.getConfig("autoSpeech")
    MNButton.setConfig(self.autoSpeechButton, {
      opacity: 1.0,
      color:(chatAIConfig.getConfig("autoSpeech")?"#457bd3":"#9bb2d6"),
      alpha:0.8,
      title:"Auto Speech "+(chatAIConfig.getConfig("autoSpeech")?"✅":"❌")
    })
    chatAIConfig.save("MNChatglm_config")
  },
  toggleSpeech:function (params) {
    chatAIConfig.config.speech = !chatAIConfig.getConfig("speech")
    MNButton.setConfig(self.speechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech "+(chatAIConfig.getConfig("speech")?"✅":"❌")})
    MNButton.setConfig(self.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice "+chatAIConfig.getConfig("speechVoice")})
    MNButton.setConfig(self.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeSpeechVoice:function (sender) {
  try {
    let voices = ["male-qn-qingse","male-qn-jingying","male-qn-badao","male-qn-daxuesheng","female-shaonv","female-yujie","female-chengshu","female-tianmei","presenter_male","presenter_female","audiobook_male_1","audiobook_male_2","audiobook_female_1","audiobook_female_2","male-qn-qingse-jingpin","male-qn-jingying-jingpin","male-qn-badao-jingpin","male-qn-daxuesheng-jingpin","female-shaonv-jingpin","female-yujie-jingpin","female-chengshu-jingpin","female-tianmei-jingpin"]
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    var commandTable = voices.map(voice=>{
      return {title:voice,object:self,selector:'changeVoiceTo:',param:voice,checked:chatAIConfig.getConfig("speechVoice") == voice}
    }) 
    self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  changeVoiceTo: function (voice) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.speechVoice = voice
    MNButton.setConfig(self.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice: "+chatAIConfig.getConfig("speechVoice")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeSpeechSpeed:function (sender) {
  try {
    let speeds = [0.5,0.75,1,1.25,1.5,1.75,2.0]
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    var commandTable = speeds.map(speed=>{
      return {title:"Speed: "+speed,object:self,selector:'changeSpeedTo:',param:speed}
    }) 
    self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  changeSpeedTo: function (speed) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.speechSpeed = speed
    MNButton.setConfig(self.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeDelay: function(sender) {
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'2.0s',object:self,selector:'changeDelayTo:',param:2.0},
      {title:'1.5s',object:self,selector:'changeDelayTo:',param:1.5},
      {title:'1.0s',object:self,selector:'changeDelayTo:',param:1.0},
      {title:'0.5s',object:self,selector:'changeDelayTo:',param:0.5},
      {title:'0s',object:self,selector:'changeDelayTo:',param:0}
    ];
    self.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,100)
  },
  changeDelayTo: function(delay) {
    chatAIConfig.config.delay = delay
    self.delayButton.setTitleForState("Delay: "+delay+"s")
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set delay to "+delay+"s")
  },
  toggleColorConfig: function (button) {
    if (chatAIConfig.config.colorConfig[button.index]) {
      chatAIConfig.config.colorConfig[button.index] = 0
      button.setTitleForState("✖️",0)
    }else{
      chatAIConfig.config.colorConfig[button.index] = 1
      button.setTitleForState("✓",0)
    }
    chatAIConfig.save("MNChatglm_config")

  },
  dynamicPromptTapped: function (button) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let autoClear = chatAIConfig.getConfig("autoClear")
    let dynamic = chatAIConfig.getConfig("dynamic")
    let temperature = chatAIConfig.getConfig("dynamicTemp")
    var commandTable = [
        {title:"✏️  Edit Prompt",object:self,selector:'editDynamicPrompt:',param:"Excute"},
        {title:(dynamic?"✅":"❌")+"  Toggle Dynamic",object:self,selector:'toggleDynamic:',param:"Copy"},
        {title:(autoClear?"✅":"❌")+"  Auto Clear Input",object:self,selector:'toggleAutoClear:',param:"Copy"},
        {title:"▶️  Test Prompt (Vision)",object:self,selector:'testDynamicPrompt:',param:"Vision"},
        {title:"▶️  Test Prompt (Text)",object:self,selector:'testDynamicPrompt:',param:"Text"},
        self.tableItem("🌡️   Temperature: "+temperature, 'changeDynamicTemp:', "")
      ]
    self.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,190,1)
    return
  },
  changeDynamicTemp: async function (param) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let options = [
      "🌡️  1.0",
      "🌡️  0.8",
      "🌡️  0.6",
      "🌡️  0.4",
      "🌡️  0.2",
      "🌡️  0.0"
    ]
    let temperatures = [1.0,0.8,0.6,0.4,0.2,0.0]
    let res = await MNUtil.userSelect("Select temperature", "选择温度", options)
    if (res) {
      let targetTemperature = temperatures[res-1]
      chatAIConfig.config.dynamicTemp = targetTemperature
      MNUtil.showHUD("Change temperature to "+targetTemperature)
      chatAIConfig.save("MNChatglm_config")
    }
  },
  testDynamicPrompt: async function (mode) {
  try {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    let userInput = ""
    let system
    let systemMessage
    let preVisionMode = chatAIUtils.visionMode
    if (mode=="Vision") {
      chatAIUtils.visionMode = true
    }
    if (chatAIUtils.currentNoteId) {
      system = chatAIConfig.dynamicPrompt.note
      systemMessage = await chatAIUtils.getNoteVarInfo(chatAIUtils.currentNoteId, system,userInput)
    }else{
      system = chatAIConfig.dynamicPrompt.text
      systemMessage = await chatAIUtils.getTextVarInfo(system,userInput)
    }
    return
    if (systemMessage) {
      MNUtil.copy(systemMessage)
      MNUtil.showHUD("Copy system message")
    }else{
      MNUtil.showHUD("Empty system message")
    }
    chatAIUtils.visionMode = preVisionMode
  } catch (error) {
    chatAIUtils.addErrorLog(error, "testDynamicPrompt")
  }
  },
  toggleDynamic:function (params) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
      if (chatAIConfig.config.dynamic) {
        chatAIConfig.config.dynamic = false
        self.dynamicButton.setTitleForState("Dynamic ❌",0)
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      }else{
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
        self.dynamicButton.setTitleForState("Dynamic ✅",0)
        chatAIConfig.config.dynamic = true
      }
      chatAIConfig.save('MNChatglm_config')
  },
  toggleAutoClear:function (params) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
      let autoClear = chatAIConfig.getConfig("autoClear")
      chatAIConfig.config.autoClear = !autoClear
      chatAIConfig.save('MNChatglm_config')
      MNUtil.showHUD("Auto clear input: "+(autoClear?"❌":"✅"))
  },
  editDynamicPrompt: function (button) {
    let self = getChatglmController()
    if (self.popoverController) {self.popoverController.dismissPopoverAnimated(true);}
    try {
      MNButton.setTitle(self.contextButton, "Text")
      MNButton.setTitle(self.SystemButton, "Note")
      self.titleInput.text = "Dynamic"
      self.titleInput.editable = false
      self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      MNButton.setColor(self.promptSaveButton, "#ff714a", 0.8)
      // copyJSON(chatAIConfig.dynamicPrompt)
      self.systemInput.text = chatAIConfig.dynamicPrompt.note
      self.contextInput.text = chatAIConfig.dynamicPrompt.text
      self.visionButton.hidden = true
      self.words.forEach((entryName,index)=>{
        self["nameButton"+index].isSelected = false
        MNButton.setColor(self["nameButton"+index], "#9bb2d6", 0.8)
      })
      self.settingViewLayout()
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleIgnoreShortText:function (button) {
    chatAIConfig.config.ignoreShortText = !chatAIConfig.config.ignoreShortText
    button.setTitleForState("Ignore short text: "+(chatAIConfig.config.ignoreShortText?"✅":"🚫"))
    if (chatAIConfig.config.ignoreShortText) {
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    }else{
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    }
    chatAIConfig.save("MNChatglm_config")

  },
  exportConfig:async function (params) {
  try {
    

    let success = await chatAIConfig.export(true,true)
    if (success) {
      // self.configNoteIdInput.text = chatAIConfig.config.syncNoteId
      chatAIConfig.save("MNChatglm_config",true)
      MNUtil.showHUD("Export Success!")
      self.refreshLastSyncTime()
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "exportConfig")
  }
  },
  importConfig:async function (params) {
    let success = await chatAIConfig.import(true,true)
    // let iCloudSync = chatAIConfig.getConfig("syncSource") === "iCloud"
    // if(iCloudSync){
    //   success = await chatAIConfig.readCloudConfig()
    // }
    if (success) {
      chatAIConfig.save(undefined,true)
      MNUtil.showHUD("Import Success!")
    }
  },
  syncConfig: async function (params) {
    chatAIConfig.sync()
  },
  toggleAutoExport: function (params) {
  try {
    if (!chatAIUtils.isSubscribed()) {
      MNUtil.showHUD("Not subscribed")
      return
    }
    chatAIConfig.config.autoExport = !chatAIConfig.getConfig("autoExport")
    MNButton.setTitle(self.autoExportButton, "Auto Export: "+(chatAIConfig.getConfig("autoExport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoImport: function (params) {
    if (!chatAIUtils.isSubscribed()) {
      MNUtil.showHUD("Not subscribed")
      return
    }
    chatAIConfig.config.autoImport = !chatAIConfig.getConfig("autoImport")
    MNButton.setTitle(self.autoImportButton, "Auto Import: "+(chatAIConfig.getConfig("autoImport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  },
  pasteConfigNoteId:async function (params) {
  try {
    let file
    let res
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "None":
        return;
      case "MNNote":
        let noteId = MNUtil.clipboardText
        let note = MNNote.new(noteId)//MNUtil.getNoteById(noteId)
        if (note) {
          self.configNoteIdInput.text = note.noteId
          chatAIConfig.config.syncNoteId = note.noteId
          chatAIConfig.save("MNChatglm_config")
          MNUtil.showHUD("Save Config NoteId")
        }else{
          MNUtil.showHUD("Note not exist!")
        }
        break;
      case "CFR2":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.r2file = file
        res = await MNUtil.input("Passward for Config","输入云端配置文件加密密码",["Cancel","Confirm"])
        if (res.button) {
          chatAIConfig.config.r2password = res.input
        }
        chatAIConfig.save("MNChatglm_config")
        break;
      case "Infi":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.InfiFile = file
        res = await MNUtil.input("Passward for Config","输入云端配置文件加密密码",["Cancel","Confirm"])
        if (res.button) {
          chatAIConfig.config.InfiPassword = res.input
        }
        chatAIConfig.save("MNChatglm_config")
        break;
      case "Webdav":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.webdavFile = file
        chatAIConfig.checkWebdavAccount(true)
        // res = await MNUtil.input("Folder for Webdav","输入webdav文件夹",["Cancel","Confirm"])
        // if (res.button) {
        //   chatAIConfig.config.webdavFolder = res.input
        // }
        // res = await MNUtil.input("UserName for Webdav","输入webdav用户名",["Cancel","Confirm"])
        // if (!res.button) {
        //   chatAIConfig.config.webdavUser = res.input
        // }
        // res = await MNUtil.input("Passward for Webdav","输入webdav密码",["Cancel","Confirm"])
        // if (!res.button) {
        //   chatAIConfig.config.webdavPassword = res.input
        // }
        chatAIConfig.save("MNChatglm_config",true)
      default:
        break;
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "pasteConfigNoteId")
  }
  },
  clearConfigNoteId:function (params) {
    self.configNoteIdInput.text = ""
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "None":
        return;
      case "MNNote":
        chatAIConfig.config.syncNoteId = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config NoteId")
        break;
      case "CFR2":
        chatAIConfig.config.r2file = ""
        chatAIConfig.config.r2password = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
      case "Infi":
        chatAIConfig.config.InfiFile = ""
        chatAIConfig.config.InfiPassword = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
      case "Webdav":
        chatAIConfig.config.webdavFile = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
    }
  },
  toggleVisionMode: function (params) {
    if (!chatAIUtils.checkSubscribe(true)) {
      return
    }
    let prompt = chatAIConfig.currentPrompt
    let vision = chatAIConfig.prompts[prompt].vision
    if (vision) {
      chatAIConfig.prompts[prompt].vision = false
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }else{
      chatAIConfig.prompts[prompt].vision = true
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }
    chatAIConfig.save("MNChatglm_prompts")
  },
  focusConfigNoteId:function (params) {
  try {
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "None":
        return;
      case "MNNote":
        let noteId = chatAIConfig.config.syncNoteId
        let note = MNNote.new(noteId)
        if (note) {
          note.focusInFloatMindMap()
        }else{
          MNUtil.showHUD("Note not exist!")
        }
        break;
      case "CFR2":
        MNUtil.copy(chatAIConfig.config.r2file)
        break;
      case "Infi":
        MNUtil.copy(chatAIConfig.config.InfiFile)
        break;
      case "Webdav":
        MNUtil.copy(chatAIConfig.config.webdavFile)
        break;
      default:
        break;
    }
  } catch (error) {
    MNUtil.showHUD("Error in focusConfigNoteId: "+error)
  }
  }
});
chatglmController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.settingImage = MNUtil.getImage(chatAIConfig.mainPath + `/setting.png`)
  this.visionImage = MNUtil.getImage(chatAIConfig.mainPath + `/vision.png`,1.5)
  this.searchedText = '';
  this.isFirst = true
  this.view.layer.shadowOffset = {width: 0, height: 0};
  this.view.layer.shadowRadius = 15;
  this.view.layer.shadowOpacity = 0.5;
  this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
  this.view.layer.cornerRadius = 11
  this.view.layer.opacity = 1.0
  this.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
  this.view.layer.borderWidth = 0
  this.highlightColor = UIColor.blendedColor( MNUtil.hexColorAlpha("#2c4d81",0.8),
    chatAIUtils.app.defaultTextColor,
    0.8
  );
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestion = async function(promptKey = chatAIConfig.currentPrompt,userInput) {
try {
  let selection = MNUtil.currentSelection
  // MNUtil.copyJSON(selection)
  if (selection.onSelection) {
    // MNUtil.showHUD("getQuestionOnText")
    let question = await this.getQuestionOnText(promptKey,userInput)
    return question
  }
  let focusNote = chatAIUtils.getFocusNote()
  // MNUtil.showHUD(message)
  if (focusNote) {
    // MNUtil.showHUD("getQuestionOnNote")
    let question = await this.getQuestionOnNote(focusNote.noteId,promptKey,userInput)
    // MNUtil.copyJSON(question)
    return question
  }
  let question = await this.getQuestionOnText(promptKey,userInput)
  return question
} catch (error) {
  chatAIUtils.addErrorLog(error, "chatglmController.getQuestion")
  throw error
}
};

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnNote = async function(noteid,prompt = chatAIConfig.currentPrompt,userInput) {
  try {
  let vision = chatAIConfig.prompts[prompt].vision
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system?.trim()
  let contextMessage
  let systemMessage
  let question
  let opt = {noteId:noteid,userInput:userInput,vision:(chatAIUtils.visionMode || !!vision)}
  contextMessage = await chatAIUtils.render(context,opt)
  if (system) {//有system指令的情况
    systemMessage = await chatAIUtils.render(system,opt)
    if (chatAIUtils.visionMode || vision) {
      let imageDatas = chatAIUtils.getImagesFromNote(MNNote.new(noteid))
      question = [{role:"system",content:systemMessage},chatAIUtils.genUserMessage(contextMessage, imageDatas)]
    }else{
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    }
    return question
  }
  //无system指令的情况
  if (chatAIUtils.visionMode || vision) {
    // let imageData = MNNote.getImageFromNote(MNNote.new(noteid))
    let imageDatas = chatAIUtils.getImagesFromNote(MNNote.new(noteid))
    question = [chatAIUtils.genUserMessage(contextMessage, imageDatas)]
  }else{
    question = [{role: "user", content: contextMessage}]
  }

  return question
    } catch (error) {
    chatAIUtils.addErrorLog(error, "getQuestionOnNote")
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnText = async function(prompt = chatAIConfig.currentPrompt,userInput) {
  try {
  let vision = chatAIConfig.prompts[prompt].vision
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system
  let opt = {userInput:userInput,vision:(chatAIUtils.visionMode || !!vision)}
  let contextMessage = await chatAIUtils.render(context,opt)
  let question
  // MNUtil.copy(contextMessage)
  if (system) {
    let systemMessage = await chatAIUtils.render(system,opt)
    if (chatAIUtils.visionMode  || vision) {
      let imageData = MNUtil.getDocImage()
      question = [{role:"system",content:systemMessage},chatAIUtils.genUserMessage(contextMessage, imageData)]
    }else{
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    }
    return question
  }
  if (chatAIUtils.visionMode || vision) {
    let imageData = MNUtil.getDocImage()
    question = [chatAIUtils.genUserMessage(contextMessage, imageData)]
  }else{
    question = [{role: "user", content: contextMessage}]
  }
  return question
    } catch (error) {
    chatAIUtils.addErrorLog(error, "chatglmController.getQuestionOnText")
    throw error;
  }

}
chatglmController.prototype.changeButtonOpacity = function(opacity) {
    this.moveButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
chatglmController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}


chatglmController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width+10
    let height = viewFrame.height
    this.settingView.frame = MNUtil.genFrame(-5, 55, width, height-65)
    this.configView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.modelView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.autoActionView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.advanceView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.syncView.frame = MNUtil.genFrame(0,0,width,height-65)
    // advanceView
    if (width<700) {
      this.orderButton.frame = MNUtil.genFrame(5,5,width-10,35)
      this.knowledgeInput.frame = {x:5,y:205,width:width-10,height:height-315}
      this.saveKnowledgeButton.frame = {x:5,y:height-105,width:width-10,height:35}
      this.speechButton.frame = MNUtil.genFrame(5,45,95,35)
      this.autoSpeechButton.frame = MNUtil.genFrame(105,45,130,35)
      this.speechSpeedButton.frame = MNUtil.genFrame(240,45,width-245,35)
      this.speechVoiceButton.frame = MNUtil.genFrame(5,85,width-10,35)
      this.autoCloseAfterAction.frame = MNUtil.genFrame(5,45,width-10,35)
      this.windowLocationButton.frame = MNUtil.genFrame(5,85,width-10,35)
      this.autoThemeButton.frame = MNUtil.genFrame(5,125,width-10,35)
      this.autoImageButton.frame = MNUtil.genFrame(5,165,width-10,35)
      // configView
      this.scrollview.frame = {x:5,y:5,width:width-10,height:150}
      // this.scrollview.contentSize = {width:width-10,height:height};

      this.contextInput.frame = {x:5,y:200,width:width-90,height:height-270}
      this.systemInput.frame = {x:5,y:200,width:width-90,height:height-270}
      if (this.titleInput.editable) {
        this.titleInput.frame = {x:5,y:160,width:width-130,height:35}
      }else{
        this.titleInput.frame = {x:5,y:160,width:width-90,height:35}
      }
      this.visionButton.frame = MNUtil.genFrame(width-120, 160, 35, 35)
      this.promptModel.frame = {x:width-80,y:160,width:75,height:35}
      this.contextButton.frame = {x:width-80,y:200,width:75,height:35}
      this.promptSaveButton.frame = {x:width-80,y:height-105,width:75,height:35}
      this.addVarButton.frame = {x:width-120,y:height-105,width:30,height:30}

      this.moveUpButton.frame = {x:width-40,y:10,width:30,height:30}
      this.moveDownButton.frame = {x:width-40,y:45,width:30,height:30}
      this.configReset.frame = {x:width-40,y:80,width:30,height:30}
      // this.deleteButton.frame = {x:width-40,y:90,width:30,height:30}
      this.newEntryButton.frame = {x:width-40,y:115,width:30,height:30}

      this.SystemButton.frame = {x:width-80,y:240,width:75,height:35}
      this.funcButton.frame = {x:width-80,y:280,width:75,height:35}
      this.actionButton.frame = {x:width-80,y:320,width:75,height:35}
    }else{
      this.orderButton.frame = MNUtil.genFrame(5,5,350,35)
      this.knowledgeInput.frame = {x:360,y:5,width:width-365,height:height-115}
      this.saveKnowledgeButton.frame = {x:360,y:height-105,width:width-365,height:35}
      this.speechButton.frame = MNUtil.genFrame(5,45,95,35)
      this.autoSpeechButton.frame = MNUtil.genFrame(105,45,130,35)
      this.speechSpeedButton.frame = MNUtil.genFrame(240,45,115,35)
      this.speechVoiceButton.frame = MNUtil.genFrame(5,85,350,35)
      this.autoCloseAfterAction.frame = MNUtil.genFrame(5,45,350,35)
      this.windowLocationButton.frame = MNUtil.genFrame(5,85,350,35)
      this.autoThemeButton.frame = MNUtil.genFrame(5,125,350,35)
      this.autoImageButton.frame = MNUtil.genFrame(5,165,350,35)
      // configView
      this.scrollview.frame = {x:5,y:5,width:350,height:height-75}
      // this.scrollview.contentSize = {width:350,height:height};
      if(this.titleInput.editable){
        this.titleInput.frame = {x:360,y:5,width:width-485,height:35}
      }else{
        this.titleInput.frame = {x:360,y:5,width:width-445,height:35}
      }
      this.visionButton.frame = MNUtil.genFrame(width-120, 5, 35, 35)
      this.contextInput.frame = {x:360,y:45,width:width-445,height:height-115}
      this.systemInput.frame = {x:360,y:45,width:width-445,height:height-115}
      this.promptModel.frame = {x:width-80,y:5,width:75,height:35}
      this.contextButton.frame = {x:width-80,y:45,width:75,height:35}
      this.SystemButton.frame = {x:width-80,y:85,width:75,height:35}
      this.promptSaveButton.frame = {x:width-80,y:height-105,width:75,height:35}
      this.addVarButton.frame = {x:width-120,y:height-105,width:30,height:30}
      this.moveUpButton.frame = {x:320,y:height-210,width:30,height:30}
      this.moveDownButton.frame = {x:320,y:height-175,width:30,height:30}
      this.configReset.frame = {x:320,y:height-140,width:30,height:30}
      // this.deleteButton.frame = {x:320,y:height-140,width:30,height:30}
      this.newEntryButton.frame = {x:320,y:height-105,width:30,height:30}
  
      this.funcButton.frame = {x:width-80,y:125,width:75,height:35}
      this.actionButton.frame = {x:width-80,y:165,width:75,height:35}
    }
    let realWidth = (width > 500)?width-150:width
    let realX = (width > 500)?155:5
    // modelView
    if (width < 500) {
      this.modelScrollview.hidden = true
    }else{
      this.modelScrollview.hidden = false
      let allSources = 11
      let initY = 5
      for (let i = 0; i < allSources; i++) {
        let buttonName = "scrollSourceButton"+i
        this[buttonName].frame = MNUtil.genFrame(5, initY, 135, 35)
        initY = initY+40
        // this.createButton(buttonName,"changeSource:","modelScrollview")
        // MNButton.setConfig(this[buttonName], {opacity:1.0,color:"#2c70de",alpha:0.8})
        // this[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
      }
    }
    this.modelScrollview.frame = MNUtil.genFrame(5, 5, 145, height-75)
    this.sourceButton.frame = MNUtil.genFrame(realX,5,realWidth-100,35)
    this.saveConfigButton.frame = MNUtil.genFrame(width-90,5,85,35)
    this.apiKeyInput.frame = MNUtil.genFrame(realX,50,realWidth-10,75)
    this.pasteApiKeyButton.frame = MNUtil.genFrame(width-95,90,85,30)
    this.URLInput.frame = MNUtil.genFrame(realX,130,realWidth-10,40)
    this.pasteURLButton.frame = MNUtil.genFrame(width-95,135,85,30)
    this.setModel(chatAIConfig.config.source)
    this.tunnelButton.frame = MNUtil.genFrame(realX,50,(realWidth-10),40)
    this.usageButton.frame = MNUtil.genFrame(realX,95,(realWidth-10),40)

    // autoView
    this.autoActionButton.frame = MNUtil.genFrame(5,5,width-110,35)
    this.delayButton.frame = MNUtil.genFrame(width-100,5,95,35)
    this.onSelectionButton.frame = MNUtil.genFrame(5,50,width-10,35)
    this.onNewExcerptButton.frame = MNUtil.genFrame(5,95,width-170,35)
    this.newExcerptTagDetection.frame = MNUtil.genFrame(width-160,95,155,35)
    this.onNoteButton.frame = MNUtil.genFrame(5,230,(width-10),35)
    this.ignoreButton.frame = MNUtil.genFrame(5,360,(width-10),35)


    // syncView
    this.syncSourceButton.frame = MNUtil.genFrame(5, 5, width-10, 35)
    this.configNoteIdInput.frame = MNUtil.genFrame(5,50,width-10,60)
    this.syncTimeButton.frame = MNUtil.genFrame(5,115,width-10,35)
    this.exportConfigButton.frame = MNUtil.genFrame(5,155,(width-15)*0.5,35)
    this.importConfigButton.frame = MNUtil.genFrame(10+(width-15)*0.5,155,(width-15)*0.5,35)
    this.autoExportButton.frame = MNUtil.genFrame(5,195,(width-15)*0.5,35)
    this.autoImportButton.frame = MNUtil.genFrame(10+(width-15)*0.5,195,(width-15)*0.5,35)
    this.pasteConfigNoteButton.frame = MNUtil.genFrame(width-70,80,60,25)
    this.clearConfigNoteButton.frame = MNUtil.genFrame(width-135,80,60,25)
    this.focusConfigNoteButton.frame = MNUtil.genFrame(width-200,80,60,25)

    let initX = 5
    let initY = 135

    for (let index = 0; index < 32; index++) {
      if (index == 8) {
        initX = 5
        initY = 175
      }
      if (index == 16) {
        initX = 5
        initY = 270
      }
      if (index == 24) {
        initX = 5
        initY = 310
      }
      this["ColorButton"+index].frame = MNUtil.genFrame(initX,initY,37,37)
      // this["ColorButton"+index].setTitleForState(chatAIConfig.config.colorConfig[index]?"✓":"✖️",0)
      this["ColorButton"+index].setTitleForState(chatAIConfig.getConfig("colorConfig")[index]?"✓":"✖️",0)
      initX = initX+40.5
    }


    let settingFrame = this.settingView.bounds
    settingFrame.x = 0
    settingFrame.y = 20
    settingFrame.height = 30
    settingFrame.width = settingFrame.width-45
    this.tabView.frame = settingFrame

    settingFrame.height = 35
    settingFrame.y = 20
    settingFrame.width = settingFrame.width-35
    // this.segmentedController.frame = settingFrame
    settingFrame.width = this.configButton.width
    settingFrame.y = 0
    settingFrame.x = 0
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = settingFrame.x + settingFrame.width + 5
    settingFrame.width = this.modelTab.width
    this.modelTab.frame = settingFrame
    settingFrame.x = settingFrame.x + settingFrame.width + 5
    settingFrame.width = this.triggerButton.width
    this.triggerButton.frame = settingFrame
    settingFrame.x = settingFrame.x + settingFrame.width + 5
    settingFrame.width = this.syncConfig.width
    this.syncConfig.frame = settingFrame
    settingFrame.x = settingFrame.x + settingFrame.width + 5
    settingFrame.width = this.advancedButton.width
    // this.advancedButton.hidden = this.view.bounds.width < 360
    this.advancedButton.frame = settingFrame
    this.tabView.contentSize = {width:settingFrame.x+settingFrame.width,height:30}
    settingFrame.y = 20
    settingFrame.x = this.tabView.frame.width + 5
    settingFrame.width = 30
    this.closeButton.frame = settingFrame

}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.createSettingView = function (){
try {
  
  //创建各分页
  // MNUtil.showHUD("createSettingView")
  let targetView = "settingView"
  let boldFont = UIFont.boldSystemFontOfSize(16)
  this.creatView(targetView,"view","#f1f6ff",0.9)
  this.settingView.hidden = true
  this.settingView.layer.cornerRadius = 15
  this.tabView = this.createScrollview("view","#ffffff",0)
  this.tabView.alwaysBounceHorizontal = true
  this.tabView.showsHorizontalScrollIndicator = false
  // this.creatView("tabView","view","#ffffff",0.0)
  this.creatView("configView",targetView,"#9bb2d6",0)

  this.creatView("modelView",targetView,"#9bb2d6",0)
  this.modelView.hidden = true

  this.creatView("autoActionView",targetView,"#9bb2d6",0)
  this.autoActionView.hidden = true

  this.creatView("advanceView",targetView,"#9bb2d6",0)
  this.advanceView.hidden = true

  this.creatView("syncView",targetView,"#9bb2d6",0)
  this.syncView.hidden = true

  this.createButton("closeButton","closeButtonTapped:","view")
  this.closeButton.layer.cornerRadius = 10;
  MNButton.setImage(this.closeButton, this.stopImage)
  MNButton.setColor(this.closeButton, "#e06c75")
  targetView = "tabView"
  //创建切换按钮
  let buttonColor = "#ffffff"
  let radius = 10
  this.createButton("configButton","configButtonTapped:",targetView)
  this.configButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.configButton, 
    {color:"#457bd3",alpha:0.9,opacity:1.0,title:"Prompt",font:17,bold:true}
  )
  let size = this.configButton.sizeThatFits({width:100,height:100})
  this.configButton.width = size.width+15

  this.createButton("modelTab","modelTabTapped:",targetView)
  this.modelTab.layer.cornerRadius = radius;
  MNButton.setConfig(this.modelTab, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Model",font:17,bold:true}
  )
  size = this.modelTab.sizeThatFits({width:100,height:100})
  this.modelTab.width = size.width+15

  this.createButton("triggerButton","triggerButtonTapped:",targetView)
  this.triggerButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.triggerButton, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Trigger",font:17,bold:true}
  )
  size = this.triggerButton.sizeThatFits({width:100,height:100})
  this.triggerButton.width = size.width+15

  this.createButton("syncConfig","syncConfigTapped:",targetView)
  this.syncConfig.layer.cornerRadius = radius;
  MNButton.setConfig(this.syncConfig, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Sync",font:17,bold:true}
  )
  size = this.syncConfig.sizeThatFits({width:100,height:100})
  this.syncConfig.width = size.width+15

  this.createButton("advancedButton","advancedButtonTapped:",targetView)
  this.advancedButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.advancedButton, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"More",font:17,bold:true}
  )
  size = this.advancedButton.sizeThatFits({width:100,height:100})
  this.advancedButton.width = size.width+15

  // this.closeButton.setTitleForState('✖️', 0);
  // this.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

  // //创建分段控制器
  // this.segmentedController = UISegmentedControl.new()
  // // this.segmentedController.segmentedControlStyle = 3
  // this.view.addSubview(this.segmentedController)
  // this.segmentedController.insertSegmentWithTitleAtIndexAnimated("Prompt", 0, true)
  // this.segmentedController.insertSegmentWithTitleAtIndexAnimated("Model", 1, true)
  // this.segmentedController.insertSegmentWithTitleAtIndexAnimated("Trigger", 2, true)
  // this.segmentedController.insertSegmentWithTitleAtIndexAnimated("Sync", 3, true)
  // this.segmentedController.insertSegmentWithTitleAtIndexAnimated("More", 4, true)
  // // this.segmentedController.setTitleTextAttributesForState({font: UIFont.boldSystemFontOfSize(20)}, 1)
  // this.segmentedController.selectedSegmentIndex = 0
  // this.segmentedController.backgroundColor = MNUtil.hexColorAlpha("#3474db",1.0)
  // // this.segmentedController.setEnabledForSegmentAtIndex(true,0)
  // // this.segmentedController.setContentOffsetForSegmentAtIndex({width:0,height:10},0)
  // this.segmentedController.setWidthForSegmentAtIndex(70,0)
  // this.segmentedController.setWidthForSegmentAtIndex(60,1)
  // this.segmentedController.setWidthForSegmentAtIndex(70,2)
  // this.segmentedController.setWidthForSegmentAtIndex(50,3)
  // this.segmentedController.layer.cornerRadius = 18
  // this.segmentedController.clipsToBounds = true
  // this.segmentedController.autoresizingMask = (1 << 0 | 1 << 3);
  // this.segmentedController.layer.masksToBounds = true;
  // this.segmentedController.selectedSegmentTintColor = UIColor.blueColor()

  try {
    
  // var attributes = NSDictionary.dictionaryWithObjectsForKeys([UIFont.boldSystemFontOfSize(15)], ["NSFont"]);
  // this.segmentedController.setTitleTextAttributesForState(attributes, 0)
  this.resizeGesture0 = new UIPanGestureRecognizer(this,"onResizeGesture0:")
  this.closeButton.addGestureRecognizer(this.resizeGesture0)
  this.resizeGesture0.view.hidden = false
  } catch (error) {
    chatAIUtils.addErrorLog(error, "createSettingView")
  }
  //创建各分页下的按钮



  //advanceView
  targetView = "advanceView"
  this.createButton("windowLocationButton","toggleWindowLocation:",targetView)
  MNButton.setConfig(this.windowLocationButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("autoThemeButton","toggleAutoTheme:",targetView)
  MNButton.setConfig(this.autoThemeButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("autoImageButton","toggleAutoImage:",targetView)
  MNButton.setConfig(this.autoImageButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("autoCloseAfterAction","toggleAutoClose:",targetView)
  MNButton.setConfig(this.autoCloseAfterAction, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("orderButton","changeSearchOrder:",targetView)
  MNButton.setConfig(this.orderButton, {opacity: 1.0,color: "#457bd3", alpha: 0.8})
  
  this.creatTextView("knowledgeInput",targetView)

  this.createButton("saveKnowledgeButton","saveKnowledgeButtonTapped:","advanceView")
  MNButton.setConfig(this.saveKnowledgeButton, {opacity: 1.0,color:"#e06c75",alpha:0.8,title:"Save Knowledge"})

  this.createButton("speechButton","toggleSpeech:","advanceView")
  MNButton.setConfig(this.speechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech "+(chatAIConfig.getConfig("speech")?"✅":"❌")})
  this.speechButton.hidden = true

  this.createButton("autoSpeechButton","toggleAutoSpeech:","advanceView")
  MNButton.setConfig(this.autoSpeechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("autoSpeech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Auto Speech "+(chatAIConfig.getConfig("autoSpeech")?"✅":"❌")})
  this.autoSpeechButton.hidden = true

  this.createButton("speechVoiceButton","changeSpeechVoice:","advanceView")
  MNButton.setConfig(this.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice: "+chatAIConfig.getConfig("speechVoice")})
  this.speechVoiceButton.hidden = true

  this.createButton("speechSpeedButton","changeSpeechSpeed:","advanceView")
  MNButton.setConfig(this.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})
  this.speechSpeedButton.hidden = true

  this.refreshView(targetView)


  //autoActionView

  targetView = "autoActionView"

  this.createButton("autoActionButton","toggleAutoAction:",targetView)
  MNButton.setRadius(this.autoActionButton,11)
  // this.autoActionButton.titleLabel.font = UIFont.boldSystemFontOfSize(17)
  this.createButton("onSelectionButton","toggleOnSelection:",targetView)
  MNButton.setRadius(this.onSelectionButton,11)
  this.createButton("onNoteButton","toggleOnNote:",targetView)
  MNButton.setRadius(this.onNoteButton,11)
  this.createButton("onNewExcerptButton","toggleOnNewExcerpt:",targetView)
  MNButton.setRadius(this.onNewExcerptButton,11)
  this.createButton("newExcerptTagDetection","toggleNewExcerptTagDetection:",targetView)
  MNButton.setRadius(this.newExcerptTagDetection,11)
  this.createButton("ignoreButton","toggleIgnoreShortText:",targetView)
  MNButton.setRadius(this.ignoreButton,11)
  this.createButton("delayButton","changeDelay:",targetView)
  MNButton.setRadius(this.delayButton,11)
  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
  for (let index = 0; index < 32; index++) {
    this["ColorButton"+index]   = UIButton.buttonWithType(0);
    this["ColorButton"+index].index = index
    this["ColorButton"+index].hidden = !chatAIConfig.getConfig("autoAction")
    if (index > 15) {
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index-16])
    }else{
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index])
    }
  }
  this.refreshView(targetView)

  this.autoActionButton.layer.opacity = 1.0

  //modelView

  targetView = "modelView"
  this.modelScrollview = this.createScrollview(targetView)
  this.modelScrollview.alwaysBounceVertical = true
  this.modelScrollview.showsVerticalScrollIndicator = false

  let allSources = chatAIConfig.allSource(true)
  let sourceIndex = allSources.indexOf(chatAIConfig.config.source)
  this.modelScrollview.contentSize = {width:145,height:11*40+5}
  for (let i = 0; i < allSources.length; i++) {
    let buttonName = "scrollSourceButton"+i
    this.createButton(buttonName,"setSourceByButton:","modelScrollview")
    this[buttonName].sourceIndex = i
    if (i === sourceIndex) {
      MNButton.setConfig(this[buttonName], {opacity:0.9,color:"#2c70de",alpha:0.8,title:allSources[i],bold:true})
    }else{
      MNButton.setConfig(this[buttonName], {opacity:0.8,color:"#9bb2d6",alpha:0.8,title:allSources[i],bold:true})
    }
    this[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
  }

  this.createButton("sourceButton","changeSource:",targetView)
  MNButton.setConfig(this.sourceButton, {opacity:1.0,color:"#2c70de",alpha:0.8})
  this.sourceButton.titleLabel.font = UIFont.boldSystemFontOfSize(17)
  MNButton.setRadius(this.sourceButton,11)

  this.createButton("tunnelButton","changeTunnel:",targetView)
  MNButton.setConfig(this.tunnelButton, {opacity:1.0,color:"#457bd3",alpha:0.8})
  MNButton.setRadius(this.tunnelButton,11)

  this.createButton("usageButton","refreshUsage:",targetView)
  this.usageButton.builtIn = true
  MNButton.setConfig(this.usageButton, {opacity:1.0,color:"#457bd3",alpha:0.8})
  MNButton.setRadius(this.usageButton,11)

  
  // this.createButton("saveCustomModels","saveCustomModels:","modelView")
  // MNButton.setTitle(this.saveCustomModels, "Save")
  this.creatTextView("customModelInput","modelView")
  // MNButton.setColor(this.saveCustomModels, "#457bd3",0.8)
  
  this.createButton("modelButton","changeModel:","modelView")
  MNButton.setColor(this.modelButton, "#457bd3",0.8)
  MNButton.setRadius(this.modelButton,11)

  this.createButton("importSubscriptionButton","importFromSubscription:","modelView")
  MNButton.setTitle(this.importSubscriptionButton, "Import from subscription")
  MNButton.setColor(this.importSubscriptionButton, "#457bd3",0.8)
  MNButton.setRadius(this.importSubscriptionButton,11)

  this.createButton("imageCompressionButton","toggleImageCompressionButton:","modelView")
  MNButton.setTitle(this.imageCompressionButton, "Image Compression for vision mode: "+(chatAIConfig.getConfig("imageCompression")?"✅":"❌"))
  MNButton.setColor(this.imageCompressionButton, "#457bd3",0.8)
  MNButton.setRadius(this.imageCompressionButton,11)

  this.createButton("customUsage","refreshUsage:","modelView")
  this.customUsage.builtIn = false
  MNButton.setConfig(this.customUsage, {title:"Usage:",color:"#457bd3",alpha:0.8})
  MNButton.setRadius(this.customUsage,11)

  this.creatTextView("apiKeyInput","modelView")
  this.apiKeyInput.bounces = true
  this.apiKeyInput.editable = true
  MNButton.setRadius(this.apiKeyInput,11)

  this.createButton("pasteApiKeyButton","pasteApiKey:","modelView")
  MNButton.setConfig(this.pasteApiKeyButton, {opacity:1.0,color:"#9bb2d6",title:"Paste key"})

  this.creatTextView("URLInput","modelView")
  MNButton.setRadius(this.URLInput,11)

  this.createButton("pasteURLButton","pasteURL:","modelView")
  MNButton.setConfig(this.pasteURLButton, {opacity:1.0,color:"#9bb2d6",title:"Paste url"})

  this.createButton("saveConfigButton","saveConfig:","modelView")
  MNButton.setConfig(this.saveConfigButton, {opacity:0.8,color:"#e06c75",title:"Save",bold:true})
  MNButton.setRadius(this.saveConfigButton,11)

  this.refreshView(targetView)

  //configView
  targetView = "configView"
  this.scrollview = this.createScrollview(targetView)
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 11
  this.scrollview.showsVerticalScrollIndicator = false
  this.scrollview.backgroundColor = MNUtil.hexColorAlpha("#b3bbc0",0.7)
  this.creatTextView("contextInput","configView")
  MNButton.setRadius(this.contextInput, 11)
  this.creatTextView("systemInput","configView")
  MNButton.setRadius(this.systemInput, 11)
  this.systemInput.hidden = true

  this.creatTextView("titleInput","configView","#9bb2d6")
  MNButton.setRadius(this.titleInput, 11)
  this.createButton("dynamicButton","dynamicPromptTapped:","scrollview")


  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  // copyJSON(chatAIConfig.prompts)
  // copy(text)
  this.titleInput.contentInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.titleInput.textContainerInset = {top: 0,left: 0,bottom: 0,right: 0}

  this.createButton("visionButton","toggleVisionMode:","configView")
  this.visionButton.setImageForState(this.visionImage,0)
  this.visionButton.backgroundColor =  MNUtil.hexColorAlpha("#c0bfbf",0.8)
  MNButton.setRadius(this.visionButton, 11)

  this.createButton("funcButton","changeFunc:","configView")
  MNButton.setConfig(this.funcButton, {opacity:1.0,title:"Tools"})
  MNButton.setRadius(this.funcButton, 11)

  this.createButton("promptModel","changePromptModel:","configView")
  MNButton.setConfig(this.promptModel, {opacity:1.0,title:"Model"})
  MNButton.setRadius(this.promptModel, 11)

  this.createButton("configReset","resetConfig:","configView")
  MNButton.setConfig(this.configReset, {opacity:0.8,title:"🔄",color:"#ffffff",alpha:0.8})

  // this.createButton("deleteButton","configDeleteTapped:","configView")
  // MNButton.setConfig(this.deleteButton, {opacity:0.8,title:"🗑",color:"#9bb2d6",alpha:0.8})

  this.createButton("newEntryButton","configAddTapped:","configView")
  MNButton.setConfig(this.newEntryButton, {opacity:0.8,title:"➕",color:"#ffffff",alpha:0.8})

  this.createButton("moveUpButton","moveForwardTapped:","configView")
  MNButton.setConfig(this.moveUpButton, {opacity:0.8,title:"🔼",color:"#ffffff",alpha:0.8})

  this.createButton("moveDownButton","moveBackwardTapped:","configView")
  MNButton.setConfig(this.moveDownButton, {opacity:0.8,title:"🔽",color:"#ffffff",alpha:0.8})

  this.createButton("promptSaveButton","promptSaveTapped:","configView")
  MNButton.setConfig(this.promptSaveButton, {opacity:0.8,title:"Save",bold:true,color:"#e06c75",alpha:0.8})
  MNButton.addLongPressGesture(this.promptSaveButton, this, "onLongPressSavePrompt:")
  MNButton.setRadius(this.promptSaveButton, 11)


  this.createButton("addVarButton","addVariable:","configView")
  MNButton.setConfig(this.addVarButton, {opacity:1.0,title:"➕"})

  this.createButton("contextButton","configContextTapped:","configView")
  MNButton.setConfig(this.contextButton, {opacity:1.0,title:"User",color:"#457bd3",alpha:0.8})
  MNButton.setRadius(this.contextButton, 11)

  this.createButton("SystemButton","configSystemTapped:","configView")
  MNButton.setConfig(this.SystemButton, {opacity:1.0,title:"System",color:"#9bb2d6",alpha:0.8})
  MNButton.setRadius(this.SystemButton, 11)

  this.createButton("actionButton","changeActions:","configView")
  MNButton.setConfig(this.actionButton, {opacity:1.0,title:"Action",color:"#9bb2d6",alpha:0.8})
  MNButton.setRadius(this.actionButton, 11)
  this.refreshView(targetView)

  //syncView
  targetView = "syncView"
  this.createButton("syncSourceButton","changeSyncSource:",targetView)
  MNButton.setConfig(this.syncSourceButton, {title:"Sync Config: "+chatAIConfig.getSyncSourceString(),color:"#457bd3",font:17,alpha:0.8,bold:true})
  MNButton.setRadius(this.syncSourceButton,11)


  this.creatTextView("configNoteIdInput",targetView)
  this.configNoteIdInput.editable = false
  this.createButton("syncTimeButton","syncConfig:",targetView)
  MNButton.setConfig(this.syncTimeButton, {color:"#457bd3",alpha:0.8})
  
  this.createButton("exportConfigButton","exportConfig:",targetView)

  this.createButton("importConfigButton","importConfig:",targetView)

  this.createButton("autoExportButton","toggleAutoExport:",targetView)
  MNButton.setConfig(this.autoExportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("autoImportButton","toggleAutoImport:",targetView)
  MNButton.setConfig(this.autoImportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("pasteConfigNoteButton","pasteConfigNoteId:",targetView)
  MNButton.setConfig(this.pasteConfigNoteButton, {title:"Paste",color:"#9bb2d6",alpha:0.8})

  this.createButton("clearConfigNoteButton","clearConfigNoteId:",targetView)
  MNButton.setConfig(this.clearConfigNoteButton, {title:"Clear",color:"#9bb2d6",alpha:0.8})

  this.createButton("focusConfigNoteButton","focusConfigNoteId:",targetView)
  MNButton.setConfig(this.focusConfigNoteButton, {title:"Focus",color:"#9bb2d6",alpha:0.8})

  this.refreshView(targetView)  


} catch (error) {
  MNUtil.showHUD(error)

}
}

/**
 * @this {chatglmController}
 * @param {string[]} names
 */
chatglmController.prototype.setButtonText = function (names,highlight) {
try {
  
    this.words = names
    // MNUtil.showHUD("count:"+names.length)
    names.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let buttonName = "nameButton"+index
      if (!this[buttonName]) {
        this.createButton(buttonName,"toggleSelected:","scrollview")
        // this[buttonName].index = index
        // MNUtil.showHUD("Create "+buttonName)
        this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this[buttonName].hidden = false
      this[buttonName].setTitleForState(chatAIConfig.prompts[word].title,0) 
      this[buttonName].id = word

      this[buttonName].isSelected = (word === highlight)
      MNButton.setColor(this[buttonName], (word === highlight) ? "#457bd3" : "#9bb2d6",0.8)
    })
    this.refreshLayout()
} catch (error) {
  MNUtil.showHUD(error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setTextview = function (name) {
      // let entries           =  NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = chatAIConfig.prompts[name]
      this.titleInput.text= text.title
      this.contextInput.text = text.context?text.context:""
      if (!text.system) {
        text.system = ""
      }
      this.systemInput.text = text.system
      if (text.vision) {
        this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
      }else{
        this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
      }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshLayout = function () {
  if (!this.settingView) {return}
  this.dynamicButton.frame = MNUtil.genFrame(8,8,110,30)
  if (!this.configView.hidden) {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 126
    let initY = 8
    let initL = 0
    this.locs = [];
    // MNUtil.copyJSON(this.words)
    // MNUtil.showHUD("words count:"+this.words.length)
    this.words.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let title = chatAIConfig.prompts[word].title
      if (!title) {
        title = "noTitle"
      }
      let width = this["nameButton"+index].sizeThatFits({width:100,height:30}).width+15
      // let width = chatAIUtils.strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-5) {
        initX = 8
        initY = initY+38
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+8
    })
    // MNUtil.copyJSON(this.locs)
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        // MNUtil.showHUD("Hidden:"+"nameButton"+index)
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }
}

chatglmController.prototype.hideAllButton = function (frame) {
  // if (condition) {
    
  // }
  // this.moveButton.hidden = true
}
chatglmController.prototype.showAllButton = function (frame) {
  // this.moveButton.hidden = false
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.show = function (frame) {
try {
  MNUtil.studyView.bringSubviewToFront(this.view)
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // this.settingView.hidden = true
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
  this.hideAllButton()

  MNUtil.animate(()=>{
    this.view.layer.opacity = preOpacity
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  }).then(()=>{
    try {
    this.view.layer.borderWidth = 0
    this.view.layer.opacity = 1.0
    // MNUtil.copy("123")
    this.showAllButton()
    this.settingView.hidden = false
    MNUtil.studyView.bringSubviewToFront(this.view)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "show")
    }
    // chatAIUtils.copyJSON(this.view.frame)
  })
  if (chatAIConfig.autoImport(true)) {
    chatAIConfig.import(false)
  }

} catch (error) {
  chatAIUtils.addErrorLog(error, "show")
}
}
chatglmController.prototype.hide = function (frame) {
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  this.hideAllButton()
  this.custom = false
  MNUtil.animate(()=>{
    this.view.layer.opacity = 0.2
  }).then(()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.custom = preCustom
  })
}

/**
 * @this {chatglmController}
 * @param {string} superview
 * @param {string} color
 * @param {number} alpha
 * @returns {UIScrollView}
 */
chatglmController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

/**
 * @this {chatglmController}
 * @param {string} superview
 * @param {string} color
 * @param {number} alpha
 * @returns {UIScrollView}
 */
chatglmController.prototype.createScrollview = function (superview="view",color="#c0bfbf",alpha=0.8) {
  let scrollview = UIScrollView.new()
  scrollview.hidden = false
  scrollview.delegate = this
  scrollview.bounces = true
  // scrollview.alwaysBounceVertical = true
  scrollview.layer.cornerRadius = 8
  scrollview.backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[superview].addSubview(scrollview)
  return scrollview
}
chatglmController.prototype.creatTextView = function (viewName,superview="view",color="#b3bbc0",alpha=0.7) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}

/**
 * 
 * @param {UIButton} button 
 * @param {*} targetAction 
 * @param {*} color 
 */
chatglmController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.autoActionView.addSubview(button);
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.fetch = async function (url,options = {}){
  return new Promise((resolve, reject) => {
    // UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    const queue = NSOperationQueue.mainQueue()
    const request = chatAINetwork.initRequest(url, options)
    NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
      request,
      queue,
      (res, data, err) => {
        if (err.localizedDescription) reject(err.localizedDescription)
        if (res.statusCode() >= 400){

        }
        // if (data.length() === 0) resolve({})
        const result = NSJSONSerialization.JSONObjectWithDataOptions(
          data,
          1<<0
        )
        if (NSJSONSerialization.isValidJSONObject(result)) resolve(result)
        resolve(result)
      }
    )
  })
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.genCardStructure = async function (noteid,OCR_enabled=false) {
  let hasImage = false
  let cardStructure = {}
  let note = MNUtil.getNoteById(noteid)
  if (note.noteTitle && note.noteTitle !== "") {
    cardStructure.title = note.noteTitle
  }
  if (note.excerptPic && !note.textFirst) {
    hasImage = true
  }
  if (OCR_enabled && note.excerptPic && !note.textFirst) {
    cardStructure.excerpt = await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(note.excerptPic.paint))
    // hasImage = true
  }else if (chatAIUtils.noteHasExcerptText(note)){
    cardStructure.excerpt = note.excerptText
  }
  if (note.comments.length) {
    let comments = []
    for (let i = 0; i < note.comments.length; i++) {
      const comment = note.comments[i];
      switch (comment.type) {
        case "TextNote":
          if (/^marginnote\dapp:\/\//.test(comment.text)) {
          }else{
            comments.push(comment.text)
          }
          break
        case "HtmlNote":
          comments.push(comment.text)
          break
        case "LinkNote":
          if (OCR_enabled && comment.q_hpic && !note.textFirst) {
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.q_hpic.paint)))
          }else{
            comments.push(comment.q_htext)
          }
          break
        case "PaintNote":
          if (comment.paint) {
            hasImage = true
          }
          if (OCR_enabled && comment.paint){
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.paint)))
          }
          break
        default:
          break
      }
    }
    if (comments.length === 1) {
      cardStructure.comment = comments[0]
    }else{
      cardStructure.comments = comments
    }
  }
  // MNUtil.copy("length:"+Object.keys(cardStructure).length)
  let keys = Object.keys(cardStructure)
  switch (keys.length) {
    case 0:
      if (hasImage) {
        return "{{image}}"
      }
      return cardStructure
    case 1:
      // 只有一个键时，不需要返回整个结构
      return cardStructure[keys[0]]
    default:
      return cardStructure
  }
  return cardStructure
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.stringifyCardStructure = function(cardStructure){
  switch (typeof cardStructure) {
    case "string":
      return cardStructure
    case "object":
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      return JSON.stringify(cardStructure,null,2)
    default:
      return undefined
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.ask = async function (promptKey = chatAIConfig.currentPrompt){
    // showHUD(promptKey)
  try {
    let question = await this.getQuestion(promptKey)
    if (!question) {
      return
    }
    chatAIUtils.notifyController.ask(question,promptKey)
    return question
  } catch (error) {
    chatAIUtils.addErrorLog(error, "chatglmController.ask")
    // MNUtil.showHUD("Error in ask: "+error)
  }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.askWithDelay = async function (promptKey = chatAIConfig.currentPrompt){
    // showHUD(promptKey)
  try {
    let question = await this.getQuestion(promptKey)
    if (!question) {
      return
    }
    let delay = chatAIConfig.config.delay
    await MNUtil.delay(delay)
    chatAIUtils.notifyController.ask(question,promptKey)
    return question
  } catch (error) {
    chatAIUtils.addErrorLog(error, "chatglmController.askWithDelay")
  }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModel = function (source) {
  let modelName = chatAIConfig.getDefaultModel(source)
  // MNUtil.copy(modelName)
  switch (source) {
    case "ChatGLM":
    case "Claude":
    case "SiliconFlow":
    case "Volcengine":
    case "Github":
    case "Gemini":
    case "ChatGPT":
    case "Subscription":
    case "KimiChat":
    case "Minimax":
    case "Deepseek":
    case "Qwen":
      MNButton.setTitle(this.modelButton, modelName)
      break;
    case "Custom":
      if (chatAIConfig.config.customModel && chatAIConfig.config.customModel.trim() === "") {
        this.modelButton.setTitleForState("No model",0) 
      }else{
        MNButton.setTitle(this.modelButton, modelName)
      }
      break;
    case "Built-in":
      break;
    default:
      MNUtil.showHUD("Unspported source: "+source)
      return
  }
  let viewFrame = this.view.bounds
  let width = viewFrame.width+10
  let realWidth = (width > 500)?width-150:width
  let realX = (width > 500)?155:5
  this.imageCompressionButton.frame = MNUtil.genFrame(realX, viewFrame.height-105, realWidth-10, 35)
  switch (source) {
    case "ChatGLM":
    case "Claude":
    case "KimiChat":
    case "SiliconFlow":
    case "Volcengine":
    case "Github":
    case "Minimax":
    case "Qwen":
    case "Deepseek":
      this.modelButton.frame = MNUtil.genFrame(realX,130,realWidth-10,35)
      break;
    case "ChatGPT":
      this.customUsage.frame = MNUtil.genFrame(realX+195,175,realWidth-205,35)
      this.modelButton.frame = MNUtil.genFrame(realX,175,190,35)
      // this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(realX, 215, realWidth-10, 65)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      this.importSubscriptionButton.frame = MNUtil.genFrame(realX, 285, realWidth-10, 35)
      break;
    case "Subscription":
      // this.customUsage.frame = MNUtil.genFrame(realX+195,50,realWidth-205,35)
      this.modelButton.frame = MNUtil.genFrame(realX,50,realWidth-10,35)
      this.customModelInput.frame = MNUtil.genFrame(realX, 90, realWidth-10, 70)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      break;
    case "Gemini":
      this.modelButton.frame = MNUtil.genFrame(realX,175,realWidth-10,35)
      break;
    case "Custom":
      this.modelButton.frame = MNUtil.genFrame(realX,175,realWidth-10,35)
      // this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(realX, 215, realWidth-10, 70)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      break;
    case "Built-in":
      break;
    default:
      MNUtil.showHUD("Unspported source: "+source)
      return
  }

}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.switchView = function (targetView) {
  let allViews = ["configView", "syncView", "advanceView", "modelView", "autoActionView"]
  let allButtons = ["configButton","syncConfig", "advancedButton", "modelTab", "triggerButton"]
  allViews.forEach((k,index) => {
    let isTargetView = k === targetView
    this[k].hidden = !isTargetView
    this[allButtons[index]].backgroundColor = MNUtil.hexColorAlpha(isTargetView?"#457bd3":"#9bb2d6",0.8)
  })
  this.refreshView(targetView)
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshView = function (targetView) {
try {
  switch (targetView) {
    case "advanceView":
      this.knowledgeInput.text = chatAIConfig.knowledge
      let locInd = chatAIConfig.config.notifyLoc
      let locNames = ["Left","Right"]
      MNButton.setTitle(this.windowLocationButton, "Notification: "+locNames[locInd])
      MNButton.setTitle(this.autoThemeButton, "Auto Theme: "+(chatAIConfig.getConfig("autoTheme")?"✅":"❌"))
      MNButton.setTitle(this.autoImageButton, "Auto Select Image: "+(chatAIConfig.getConfig("autoImage")?"✅":"❌"))
      MNButton.setTitle(this.autoCloseAfterAction, "Auto Close After Action: "+(chatAIConfig.getConfig("autoClose")?"✅":"❌"))
      MNButton.setTitle(this.orderButton, chatAIConfig.getOrderText())
      break;
    case "modelView":
      MNButton.setTitle(this.sourceButton, "Source: "+chatAIConfig.getConfig("source"),17,true)
      chatAIConfig.getTunnels().then((tunnels)=>{
        this.tunnelButton.setTitleForState(tunnels[chatAIConfig.getConfig("tunnel")],0)
      })
      // let tunnels = ['Tunnel1️⃣: '+chatAIConfig.keys["key0"].model,'Tunnel2️⃣: '+chatAIConfig.keys["key1"].model,'Tunnel3️⃣: '+chatAIConfig.keys["key2"].model,'Tunnel4️⃣: '+chatAIConfig.keys["key3"].model]
      if (chatAIUtils.checkSubscribe(false,false,true)) {
        this.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
      this.setModel(chatAIConfig.config.source)
      this.setModelButton(chatAIConfig.config.source)
      break;
    case "configView":
      if (chatAIConfig.getConfig("dynamic")) {
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#fd3700",alpha:0.8,title:"Dynamic ✅",bold:true})
      }else{
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#ff9375",alpha:0.8,title:"Dynamic ❌",bold:true})
      }
      if (this.titleInput.editable) {
        let text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
        if (!text) {
          chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
          text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
        }
        this.contextInput.text = text.context?text.context:""
        this.titleInput.text = text.title
        this.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
        this.setTextview(chatAIConfig.currentPrompt)
      }else{
        MNButton.setTitle(this.contextButton, "Text")
        MNButton.setTitle(this.SystemButton, "Note")
        this.titleInput.text = "Dynamic"
        this.titleInput.editable = false
        this.titleInput.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
        MNButton.setColor(this.promptSaveButton, "#ff714a", 0.8)
        // copyJSON(chatAIConfig.dynamicPrompt)
        this.systemInput.text = chatAIConfig.dynamicPrompt.note
        this.contextInput.text = chatAIConfig.dynamicPrompt.text
        this.visionButton.hidden = true
        this.words.forEach((entryName,index)=>{
          this["nameButton"+index].isSelected = false
          MNButton.setColor(this["nameButton"+index], "#9bb2d6", 0.8)
        })
      }
      // MNUtil.copyJSON(chatAIConfig.config)
      break;
    case "syncView":
      let syncSource = chatAIConfig.getConfig("syncSource")
      this.configNoteIdInput.hidden = (syncSource === "iCloud" || syncSource === "None")
      this.focusConfigNoteButton.hidden = (syncSource === "iCloud" || syncSource === "None")
      this.clearConfigNoteButton.hidden = (syncSource === "iCloud" || syncSource === "None")
      this.pasteConfigNoteButton.hidden = (syncSource === "iCloud" || syncSource === "None")
      this.syncTimeButton.hidden = (syncSource === "None")
      this.autoExportButton.hidden = (syncSource === "None")
      this.autoImportButton.hidden = (syncSource === "None")
      this.exportConfigButton.hidden = (syncSource === "None")
      this.importConfigButton.hidden = (syncSource === "None")
      switch (syncSource) {
        case "None":
          break;
        case "iCloud":
          MNButton.setTitle(this.exportConfigButton, "Export to iCloud")
          MNButton.setTitle(this.importConfigButton, "Import from iCloud")
          MNButton.setTitle(this.focusConfigNoteButton, "Focus")
          // this.focusConfigNoteButton.hidden = syncSource === "iCloud"
          break;
        case "MNNote":
          MNButton.setTitle(this.focusConfigNoteButton, "Focus")
          MNButton.setTitle(this.exportConfigButton, "Export to Note")
          MNButton.setTitle(this.importConfigButton, "Import from Note")
          // this.focusConfigNoteButton.hidden = syncSource === "MNNote"
          this.configNoteIdInput.text = chatAIConfig.getConfig("syncNoteId")
          break;
        case "CFR2":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to R2")
          MNButton.setTitle(this.importConfigButton, "Import from R2")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("r2file")
          break;
        case "Infi":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to Infi")
          MNButton.setTitle(this.importConfigButton, "Import from Infi")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("InfiFile")
          break;
        case "Webdav":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to Webdav")
          MNButton.setTitle(this.importConfigButton, "Import from Webdav")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("webdavFile")
          break;
        default:
          break;
      }
      let autoImport = chatAIConfig.autoImport(true)
      MNButton.setTitle(this.autoExportButton, "Auto Export: "+(autoImport?"✅":"❌"))
      MNButton.setTitle(this.autoImportButton, "Auto Import: "+(autoImport?"✅":"❌"))
      this.refreshLastSyncTime()
      break;
    case "autoActionView":
      MNButton.setTitle(this.ignoreButton, "Ignore short text: "+(chatAIConfig.getConfig("ignoreShortText")?"✅":"🚫"))
      if (chatAIConfig.getConfig("ignoreShortText")) {
        MNButton.setColor(this.ignoreButton, "#457bd3", 0.8)
      }else{
        MNButton.setColor(this.ignoreButton, "#9bb2d6", 0.8)
      }
      let autoAction = chatAIConfig.getConfig("autoAction")
      MNButton.setTitle(this.delayButton, "Delay: "+chatAIConfig.config.delay+"s")
      MNButton.setColor(this.delayButton, "#457bd3",0.8)
      MNButton.setColor(this.autoActionButton, autoAction?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.autoActionButton, autoAction?"Enable trigger: ✅":"Enable trigger: ❌",17,true)
      this.onSelectionButton.hidden = !autoAction
      this.onNewExcerptButton.hidden = !autoAction
      this.newExcerptTagDetection.hidden = !autoAction
      this.onNoteButton.hidden = !autoAction
      this.ignoreButton.hidden = !autoAction
      this.delayButton.hidden = false
      let onSelection = chatAIConfig.config.onSelection
      MNButton.setColor(this.onSelectionButton, onSelection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onSelectionButton, onSelection?"On Selection: ✅":"On Selection: ❌")
      let onNote = chatAIConfig.config.onNote
      MNButton.setColor(this.onNoteButton, onNote?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNoteButton, onNote?"On Note: ✅":"On Note: ❌")
      let onNewExcerpt = chatAIConfig.config.onNewExcerpt
      MNButton.setColor(this.onNewExcerptButton, onNewExcerpt?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNewExcerptButton, onNewExcerpt?"On New Excerpt: ✅":"On New Excerpt: ❌")
      let newExcerptTagDetection = chatAIConfig.config.newExcerptTagDetection
      MNButton.setColor(this.newExcerptTagDetection, newExcerptTagDetection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.newExcerptTagDetection, newExcerptTagDetection?"Tag detection: ✅":"Tag detection: ❌")
      for (let index = 0; index < 32; index++) {
        this["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
      }
      MNUtil.refreshAddonCommands()
      break;
    default:
      break;
  }
} catch (error) {
  MNUtil.showHUD("Error in refreshView: "+error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModelButton = function (source) {
  if (source == "ChatGPT") {
    this.URLInput.hidden = false
    this.pasteURLButton.hidden = false
    // this.saveURLButton.hidden = false
    // this.saveCustomModels.hidden = false
    this.customModelInput.hidden = false
    this.customUsage.hidden = false
    if (typeof subscriptionConfig === 'undefined') {
      this.importSubscriptionButton.hidden = true
    }else{
      this.importSubscriptionButton.hidden = !chatAIUtils.checkSubscribe(false)
    }
  }else{
    this.URLInput.hidden = true
    this.pasteURLButton.hidden = true
    // this.saveURLButton.hidden = true
    // this.saveCustomModels.hidden = true
    this.customModelInput.hidden = true
    this.customUsage.hidden = true
    this.importSubscriptionButton.hidden = true
  }
  if (source == "Built-in") {
    MNButton.setConfig(this.saveConfigButton, {title:"Refresh",bold:true})
    this.apiKeyInput.hidden = true
    this.pasteApiKeyButton.hidden = true
    this.modelButton.hidden = true
    this.tunnelButton.hidden = false
    this.usageButton.hidden = false
  }else{
    MNButton.setConfig(this.saveConfigButton, {title:"Save",bold:true})
    this.apiKeyInput.hidden = false
    this.pasteApiKeyButton.hidden = false
    this.modelButton.hidden = false
    this.tunnelButton.hidden = true
    this.usageButton.hidden = true
  }
  let config = chatAIConfig.getConfigFromSource(source)
  this.apiKeyInput.text = config.key
  switch (source) {
      case "ChatGPT":
        let URL = config.url
        if (URL === "") {
          URL = `https://api.openai.com`
        }else{
          URL = URL.replace("/v1/chat/completions","")
        }
        this.URLInput.text = URL
        break;
      case "Built-in":
        if (chatAIUtils.checkSubscribe(false,false,true)) {
          this.usageButton.setTitleForState("Unlimited",0)
        }else{
          let usage  = chatAIConfig.usage
          this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
        }
        break;
      case "Gemini":
        this.pasteURLButton.hidden = false
        this.URLInput.hidden = false
        if (config.url === "https://generativelanguage.googleapis.com") {
          this.URLInput.text = 'https://generativelanguage.googleapis.com/v1beta/openai/chat/completions'
        }else{
          this.URLInput.text = config.url
        }
        break;
      case "Custom":
        this.URLInput.text = chatAIConfig.config.customUrl ?? ""
        this.usageButton.hidden = true
        this.pasteURLButton.hidden = false
        // this.saveURLButton.hidden = false
        this.URLInput.hidden = false
        this.customModelInput.hidden = false
        // this.saveCustomModels.hidden = false
        break;
      case "Subscription":
        this.apiKeyInput.hidden = true
        this.customUsage.hidden = true
        this.usageButton.hidden = true
        this.pasteURLButton.hidden = true
        // this.saveURLButton.hidden = false
        this.customModelInput.hidden = false
        this.pasteApiKeyButton.hidden = true
        // this.saveCustomModels.hidden = false
        break;
      default:
        break;
    }
}
/**
 * @this {chatglmController}
 * @param {*} sender 
 * @param {*} commandTable 
 * @param {*} width 
 * @param {*} direction 
 */
chatglmController.prototype.popover = function(sender,commandTable,width=200,direction=2){
  this.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,width,direction)
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.checkPopover = function(){
  if (this.popoverController) {
    this.popoverController.dismissPopoverAnimated(true)
  }
}
chatglmController.prototype.refreshLastSyncTime = function () {
  let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
  MNButton.setTitle(this.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
}
/**
 * 
 * @param {string} title 
 * @param {string} selector 
 * @param {any} param 
 * @param {boolean|undefined} checked 
 * @this {chatglmController}
 * @returns 
 */
chatglmController.prototype.tableItem = function (title,selector,param = "",checked = false) {
  return {title:title,object:this,selector:selector,param:param,checked:checked}
}
/**
 * 
 * @param {string} title 
 * @param {number} duration 
 * @param {UIView} view 
 */
chatglmController.prototype.showHUD = function (title,duration = 1.5,view = self.view) {
  MNUtil.showHUD(title,duration,view)
}
/** @type {UITextView} */
chatglmController.prototype.contextInput